import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.layout.GridLayout;
import java.util.LinkedList;

public class Library {

	Display display;
	Shell target_shell;//dit block ska skickas
	Canvas target_canvas;//dit block ska skickas 
	
	//innehåller alla boxar som visas på canvasen
	LinkedList active_block_list = new LinkedList();
	Shell library_shell = null;
	
	public Library(Shell shell_in, Display display_in, Canvas canvas_in){
		display = display_in;
		target_shell=shell_in;
		target_canvas=canvas_in;
	}
	
	
	public void create_library(){
		library_shell = new Shell(display);//, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
	    
	    GridLayout grid_layout = new GridLayout();
	    library_shell.setLayout(grid_layout);
	    grid_layout.numColumns = 2;
		grid_layout.makeColumnsEqualWidth=false;
	   
//------TREE	    
	    final Tree tree = new Tree (library_shell,  SWT.V_SCROLL| SWT.H_SCROLL );
	    GridData tree_grid_data= new GridData();
		tree_grid_data.verticalAlignment = GridData.FILL;
	    //gridData.verticalSpan = 2;
		tree_grid_data.grabExcessVerticalSpace = true;
		//tree_grid_data.horizontalAlignment = GridData.FILL;
		//tree_grid_data.grabExcessHorizontalSpace = true;
		//tree_grid_data.heightHint = 200;
		//tree_grid_data.widthHint = 200;
		tree_grid_data.widthHint = 200;
		tree.setLayoutData(tree_grid_data);
		tree.setBackground(display.getSystemColor(SWT.COLOR_WIDGET_BACKGROUND));
		Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		tree.setFont(font);
		font.dispose();
		final TreeItem common_item = new TreeItem (tree, 0);
		common_item.setText("Common Blocks");
		TreeItem source_item = new TreeItem (common_item, 0);
		source_item.setText("Sources");
		TreeItem math_item = new TreeItem (common_item, 0);
		math_item.setText("Math operations");
		
		
		/*for (int i=0; i<4; i++) {
			TreeItem iItem = new TreeItem (tree, 0);
			iItem.setText ("TreeItem (0) -" + i);
			for (int j=0; j<4; j++) {
				TreeItem jItem = new TreeItem (iItem, 0);
				jItem.setText ("TreeItem (1) -" + j);
				for (int k=0; k<4; k++) {
					TreeItem kItem = new TreeItem (jItem, 0);
					kItem.setText ("TreeItem (2) -" + k);
					for (int l=0; l<4; l++) {
						TreeItem lItem = new TreeItem (kItem, 0);
						lItem.setText ("TreeItem (3) -" + l);
					}
				}
			}
		}*/
	    
	    
//------CANVAS	    
	    final Canvas library_canvas = new Canvas(library_shell,SWT.NO_REDRAW_RESIZE);
	    GridData canvas_grid_data= new GridData();
		canvas_grid_data.verticalAlignment = GridData.FILL;
	    //gridData.verticalSpan = 2;
		canvas_grid_data.grabExcessVerticalSpace = true;
		canvas_grid_data.horizontalAlignment = GridData.FILL;
		canvas_grid_data.grabExcessHorizontalSpace = true;
		canvas_grid_data.heightHint = 600;
		canvas_grid_data.widthHint = 600;
		library_canvas.setLayoutData(canvas_grid_data);
	    
		
//------LYSSNARE
		//träd
		tree.addListener(SWT.Selection, new Listener() {
		      public void handleEvent(Event event) {
		    	  active_block_list.clear();//tömmer listan och lägger i de som visas
		    	  		    	 
		    	  //ger den treeitem man valt i en vektor
		    	  TreeItem[] selection = tree.getSelection(); 
		          for (int i = 0; i < selection.length; i++)
		        	  System.out.println(selection[i]);
		          
		          if ( selection.length==1){//när man trycker på tangent (bokstav) så avfyras denna selection utan att en item är vald och ger en tom vektor
			          if(selection[0]==common_item ){ 
			        	  System.out.println("common item");
			        	  Add add = new Add(20,20,display,library_shell, library_canvas);
			        	  FunctionIdentity func_add = add;
			        	  func_add.get_box().uppdatera_area();
			        	  active_block_list.add(func_add);
			        	  
			        	  FunctionIdentity fi = new Constant(100,20,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Scope(180,20,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Gain(260,20,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new TransferFunction(340,20,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Subtract(420,20,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Derivative(500,20,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Subsystem(20,100,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new SignalThrough(100,100,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Step(180,100,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Ramp(260,100,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Saturation(340,100,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Random(420,100,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new AnyFunction(500,100,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Clock(20,180,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new CreateVector(100,180,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new SplitVector(180,180,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new RealTimeScope(260,180,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Sine(340,180,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Cosine(420,180,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new GoSimControl(500,180,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new ToConsole(20,260,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new SignalGenerator(100,260,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new Scope1(180,260,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new RealTimeConstant(260,260,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  fi = new FFT(340,260,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  
			        	  
			        	  
			        	  fi = new ShowValue(20,420,display,library_shell, library_canvas);
			        	  fi.get_box().uppdatera_area();
			        	  active_block_list.add(fi);
			        	  
			        	  
			        	  
			          }
		          }
		        	  
		         
		        }
		      });
		
	    
		library_canvas.addMouseListener(new MouseAdapter() {
		    public void mouseDown(MouseEvent e) { 
		    	System.out.println("mouseDown");
		    	
		    	if(is_shell_active()==false){
		    		GoSim.text.append("\nYou closed the subspace last active "
		    				+"without activating a new window, "
		    				+"library has become inactive. "
		    				+"Click on a workspace or click the library button "
		    				+"to activate the library.");
		    	}
		    	
		    	for(int i=0; i<active_block_list.size(); i++){
		    		FunctionIdentity fi =(FunctionIdentity)active_block_list.get(i);
		    		if (fi.get_box().is_within(e.x,e.y) && is_shell_active() ){
		    			System.out.println("över block");
		    			FunctionIdentity fi1=fi.copy(50, 50, display, target_shell, target_canvas);
				    	fi1.get_box().uppdatera_area();
				    	//tar reda på var boxen ska skickas, kollar först huvudarean
				    	if(target_shell==GoSim.shell)
				    		GoSim.box_list.addFirst(fi1.get_box());//först i listan så man direkt kan klicka på den
				    	else{//kollar nu subsystems
				    		for(int j=0; j<GoSim.sub_systems_list.size(); j++){
								Box box =(Box)GoSim.sub_systems_list.get(j);
								Subsystem ss = (Subsystem)box.function_identity;
								if(ss.open_window==true){//kan ha stängt ss och library är kvar öppen
									if(target_shell==ss.ss_shell){
										ss.ss_box_list.addFirst(fi1.get_box());
										break;
									}
								}
				    		}
				    	}
				    	if(fi1.get_box().function_type==4){//det är subsystem
				    		GoSim.sub_systems_list.add(fi1.get_box());
				    		GoSim.update_ss_count();
				    		int temp = ((Subsystem)fi1).ss_count; 
				    		fi1.get_box().set_title("Subsystem"+Integer.toString(temp) );
				    	}
				    	GoSim.update_all_box_menus();//för subsystems som läggs till och så att boxen vet att den är i huvudcanvasen
		    		}
		    	}
		    	
		    }
		});
		
		library_canvas.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
					
				//ger boxarna aktuell GC och ritar dem
				for(int i=0; i<active_block_list.size(); i++){
					FunctionIdentity fi =(FunctionIdentity)active_block_list.get(i);
					Box box = fi.get_box();
			    	box.set_GC(e.gc);
			    	box.draw();
				}
					
			}
		});
		
		
		
		
//library_shell lyssnare	
		library_shell.addShellListener(new ShellAdapter() {
			//denna aktiveras när fönstret stängs
			public void shellClosed(ShellEvent e) {
				GoSim.library=null; //så att man vet att den är stängd						
			}
		});
		
	    
	    //library_shell.setSize (200, 200);
	    library_shell.setText("GoSim Library - click on a block to have it created in your last active work space");
	    library_shell.pack();
	    library_shell.open();
	    while (!library_shell.isDisposed()) {
	      if (!display.readAndDispatch())
	        display.sleep();
	    }
	     
	  
	}
	
	//kollar om den shell som skickas in är aktiv, detta är viktigt för 
	//man kan ha öppnat detta fönster med ett sybsystem och sen stängt den,
	//om den har stängts så händer inget om man trycker på ett block, man
	//får bara ett felmeddelande i mouselistener ovan
	public boolean is_shell_active(){
		//kollar först huvudarean
    	if(target_shell==GoSim.shell)
    		return true;
    	else{//kollar nu subsystems
    		for(int j=0; j<GoSim.sub_systems_list.size(); j++){
				Box box =(Box)GoSim.sub_systems_list.get(j);
				Subsystem ss = (Subsystem)box.function_identity;
				if(ss.open_window==true){//kan ha stängt ss och library är kvar öppen
					if(target_shell==ss.ss_shell){
						return true;
					}
				}
    		}
    	}
    	
    	return false;
	}
	
	
	
	
	
	
}