import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.Serializable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Scale; 


public class RealTimeConstant implements FunctionIdentity, Serializable{
	
	//för serializable, en flagga för att detektera om man gör
	//stora ändringar i sin klass, inte ett måste men får bort en varning
	private static final long serialVersionUID = 1234L;
	
	
			
	Box box=null;
	String constant_val = "0";//värdet på konstanten 
	String constant_val_temp = "0";//temp för GUI
	
	//skalan räknas ut med formen kx+m där k är inc och m är min och x är 
	//heltalssteg from 0 som ges av scale
	Double scale_min = new Double(0);//skalans minsta värde
	Double scale_min_temp = new Double(0);//temp för GUI
	Double scale_max = new Double(100);//skalans maxvärde
	Double scale_max_temp = new Double(100);//temp för GUI
	Double scale_inc = new Double(1);//skalans steg (increment)
	Double scale_inc_temp = new Double(1);//temp för GUI
	
	int scale_max_swt = 100;//skalans maxvärde för SWT, inte
	//den uträknade, denna är alltid en positiv int, den motsvarar
	//antal steg som scale måste ta för att komma till maxvärdet
	//som valts
	int skal_pos=0;//skalans position sparas och initieras i options
	
	
	//objekt för synkronisering, static eftersom object ej är serializible
	//verkar gå bra att använda synchronized på en static 
	static Object synch_obj = new Object();	
	
	boolean allow_write = true;//flagga för att tråden är klar med att skriva
	//fil och konstantvärdet kan uppdateras
	
	transient Shell options_shell;//för att kunna stänga fönstret när simulering
	//eller GoSim avslutas
	
	
	//constructor
	public RealTimeConstant(int x,int y, Display display_in, Shell sh, Canvas ca){
		
		box = new Box(x, y, display_in, sh, ca);
		box.set_number_inputs(0);
		box.set_number_outputs(1);
		box.create_menu();//måste vara efter set_inputs/outputs eftersom menyn behöver deras värden
		box.set_height_and_width(45,45);
		box.set_title("Real Time\nConstant");
		box.set_function_type(1);
		box.set_FunctionIdentity(this);
		
	}
	
	//ritar detta blocks utseende i boxen
		//visar konstanten om <= 5 siffror (.0 ges alltid av Double till
		//string vilket motsvarar 2 siffror (bokstäver i strängen vid konvertering) ),
		//annars visar den ett stort C
		public void draw_graphics(){
			if(constant_val.length()<=4){
				Font font = new Font( box.display, new FontData( "Arial", 12, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
				box.gc.setFont(font);
				box.gc.drawText(constant_val, box.x_start+4, box.y_start+14, true); //true gör att ingen bakgrund ritas bakom texten
				font.dispose();
			}
			else if(constant_val.length()<=8){
				Font font = new Font( box.display, new FontData( "Arial", 12, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
				box.gc.setFont(font);
				box.gc.drawText(constant_val.substring(0,4)+"\n"+constant_val.substring(4,constant_val.length() ), box.x_start+4, box.y_start+6, true); //true gör att ingen bakgrund ritas bakom texten
				font.dispose();
			}
			else if(constant_val.length()>8){
				Font font = new Font( box.display, new FontData( "Arial", 20, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
				box.gc.setFont(font);
				box.gc.drawText("C", box.x_start+12, box.y_start+8, true); //true gör att ingen bakgrund ritas bakom texten
				font.dispose();
			}
		}
	
		//ger boxen detta funktionsobjekt sitter i
	public Box get_box(){
		return box;
	}
		
	//kopierar interfacet som instansierats som Add..nåt sånt...
	//blir en kopia iaf
	public FunctionIdentity copy(int x,int y, Display display_in, Shell sh, Canvas ca){
		return new RealTimeConstant(x, y, display_in, sh, ca);
	}
	
	//ger strängen som ska skrivas för funktionen i skriptet
	public String get_function(){
		return "RealTimeConstant";
	}
	
	//ger parametrar som användaren sätter för funktionen
	public String[] get_parameters(){
		return new String[]{"="+constant_val+";\n","='"+GoSim.global_path+"/temp/RealTimeConstant_"+box.script_name+"';\n"};
	}
	
	//sträng som skrivs före loopen, "" gör att inget skrivs
	public String get_pre_loop_string(){
		return "";
	}

	//sträng som skrivs efter loopen, "" gör att inget skrivs
	public String get_post_loop_string(){
		return "";
	}
	
	
	//GUI:t
	public void options(){
		//aktivering av options med shell.setActive() fungerar ej från menyn,
		//oklart varför
		//stänger och startar om fönstret om det är öppet
		
	
		if(options_shell!=null){//är null om aldrig öppnats
			if(!options_shell.isDisposed() )//öppen, 
				options_shell.dispose();
		}
		
		
		options_shell = new Shell(this.box.display);//, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		GridLayout grid_layout = new GridLayout();
		options_shell.setLayout(grid_layout);
		grid_layout.numColumns = 2;
		grid_layout.makeColumnsEqualWidth=true;



		//info-Text
		Text info_text = new Text(options_shell,SWT.READ_ONLY  | SWT.MULTI  | SWT.WRAP);// | SWT.V_SCROLL); //SWT.NULL);
		Font font = new Font( box.display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		info_text.setFont(font);
		info_text.setBackground(box.display.getSystemColor(SWT.COLOR_WIDGET_BACKGROUND));
		info_text.setText("Real time constant sets a value in real time.\n\n" +
				"The scale can be changed with the arrow buttons (1 step) and " +
				"Page Up/Down (10 steps) and Home/End (min/max) and of course the mouse.\n\n" +
				"Using the keyboard eliminates the lag in the scope if " +
				"you are watching it during simulation.\n\n" +
				"The synchronization with an open scope is poor when " +
				"the simulation time is short.\n\n");
		GridData info_text_grid_data= new GridData();
		info_text_grid_data.horizontalSpan = 2;
		//info_label_grid_data.heightHint = 700;
		info_text_grid_data.widthHint = 500;
		info_text.setLayoutData(info_text_grid_data);

		
		
		//------TEXTFÄLT
		//tar in siffor till konstantvärdet
		final Text constant_val_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//t1.setTabs(10);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		constant_val_text.setFont(font);
		constant_val_text.setFocus();
		constant_val_text.setText(constant_val );
		constant_val_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		GridData const_val_text_grid_data = new GridData();
		const_val_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		const_val_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		constant_val_text.setLayoutData(const_val_text_grid_data);
		
		//set-KNAPP
		final Button set_button = new Button(options_shell, SWT.PUSH);
		set_button.setFont(font);
		set_button.setText("Set value");
		GridData set_button_grid_data= new GridData();
		set_button_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		set_button_grid_data.horizontalAlignment = GridData.FILL;
		//buttonOK_grid_data.grabExcessHorizontalSpace = true;
		//buttonOK_grid_data.heightHint = 30;
		//buttonOK_grid_data.widthHint = 500;
		set_button.setLayoutData(set_button_grid_data);
		
		//scale
		final Scale constant_scale = new Scale(options_shell, SWT.HORIZONTAL);
		constant_scale.setMinimum(0 );
		constant_scale.setMaximum(scale_max_swt );
		constant_scale.setIncrement(1 );
		constant_scale.setSelection(skal_pos);
		GridData constant_scale_grid_data = new GridData();
		constant_scale_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		constant_scale_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		constant_scale_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//constant_scale_grid_data.heightHint = 20;
		//constant_scale_grid_data.widthHint = 100;
		constant_scale.setLayoutData(constant_scale_grid_data);
		
		//scale min-Label
		Label scale_min_label = new Label(options_shell, SWT.NULL);
		scale_min_label.setFont(font);
		scale_min_label.setText("Scale min:");

		//scale_min-värde
		final Text scale_min_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		scale_min_text.setFont(font);
		scale_min_text.setText(scale_min.toString() );
		scale_min_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		GridData scale_min_text_grid_data = new GridData();
		scale_min_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		scale_min_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		scale_min_text.setLayoutData(scale_min_text_grid_data);
		
		//scale max-Label
		Label scale_max_label = new Label(options_shell, SWT.NULL);
		scale_max_label.setFont(font);
		scale_max_label.setText("Scale max:");

		//scale_max-värde
		final Text scale_max_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		scale_max_text.setFont(font);
		scale_max_text.setText(scale_max.toString() );
		scale_max_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		GridData scale_max_text_grid_data = new GridData();
		scale_max_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		scale_max_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		scale_max_text.setLayoutData(scale_max_text_grid_data);

		//scale increment-Label
		Label scale_inc_label = new Label(options_shell, SWT.NULL);
		scale_inc_label.setFont(font);
		scale_inc_label.setText("Scale increment:");

		//scale_inc-värde
		final Text scale_inc_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		scale_inc_text.setFont(font);
		scale_inc_text.setText(scale_inc.toString() );
		scale_inc_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		GridData scale_inc_text_grid_data = new GridData();
		scale_inc_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		scale_inc_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		scale_inc_text.setLayoutData(scale_inc_text_grid_data);

		//set_scale-knapp
		final Button set_scale_button = new Button(options_shell, SWT.PUSH);
		set_scale_button.setFont(font);
		set_scale_button.setText("Set scale");
		GridData set_scale_button_grid_data= new GridData();
		set_scale_button_grid_data.verticalAlignment = GridData.FILL;
		set_scale_button_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		set_scale_button_grid_data.horizontalAlignment = GridData.FILL;
		//buttonOK_grid_data.grabExcessHorizontalSpace = true;
		//buttonOK_grid_data.heightHint = 30;
		//buttonOK_grid_data.widthHint = 500;
		set_scale_button.setLayoutData(set_scale_button_grid_data);
		
		
		
		//KNAPPAR
		final Button buttonOK = new Button(options_shell, SWT.PUSH);
		buttonOK.setFont(font);
		buttonOK.setText("Ok");
		GridData buttonOK_grid_data= new GridData();
		buttonOK_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		buttonOK_grid_data.horizontalAlignment = GridData.FILL;
		//buttonOK_grid_data.grabExcessHorizontalSpace = true;
		//buttonOK_grid_data.heightHint = 30;
		//buttonOK_grid_data.widthHint = 500;
		buttonOK.setLayoutData(buttonOK_grid_data);

		Button buttonCancel = new Button(options_shell, SWT.PUSH);
		buttonCancel.setFont(font);
		buttonCancel.setText("Cancel");
		buttonCancel.setLayoutData(buttonOK_grid_data);

		//LYSSNARE
		constant_val_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				constant_val_temp=constant_val_text.getText();
				Double temp;
				try {
					temp = new Double(constant_val_text.getText() );
					constant_val_temp=temp.toString();
					buttonOK.setEnabled(true);
					set_button.setEnabled(true);
				} catch (Exception e) {
					constant_val_temp = constant_val;
					buttonOK.setEnabled(false);
					set_button.setEnabled(false);
				}
				//ej definitivt men tecken till användaren
			}
		});
		set_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				
				synchronized(synch_obj){//synkad med tråden som skriver värdet i fil så bara en åt gången kan ändra
					constant_val=constant_val_temp;
				}
				
				if(GoSim.process!=null && allow_write){//sätt endast värde om sim körs och tråden skrivit värde
					write_file_synch();
				}
				
				box.uppdatera_area();

			}
		});
		//scale-lyssnare
		constant_scale.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				synchronized(synch_obj){
					constant_val=String.valueOf(constant_scale.getSelection()*scale_inc.doubleValue()+scale_min.doubleValue() );//kx+m
				}
				
				if(GoSim.process!=null && allow_write){//sätt endast värde om sim körs och tråden skrivit värde
					write_file_synch();
				}
				
				//sparar skal_pos, så den är rätt även om man sparar
				//med öppet fönster eller stänger/öppnar nytt fönster
				skal_pos=constant_scale.getSelection();
				
				constant_val_text.setText(constant_val);
				box.uppdatera_area();

			}
		});
		//scale-min/max/inc-lyssnare
		scale_min_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					scale_min_temp = new Double(scale_min_text.getText() );
					buttonOK.setEnabled(true);
					set_scale_button.setEnabled(true);
				} catch (Exception e) {
					scale_min_temp = scale_min;
					buttonOK.setEnabled(false);
					set_scale_button.setEnabled(false);
				}
				//ej definitivt men tecken till användaren
			}
		});
		scale_max_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					scale_max_temp = new Double(scale_max_text.getText() );
					buttonOK.setEnabled(true);
					set_scale_button.setEnabled(true);
				} catch (Exception e) {
					scale_max_temp = scale_max;
					buttonOK.setEnabled(false);
					set_scale_button.setEnabled(false);
				}
				//ej definitivt men tecken till användaren
			}
		});
		scale_inc_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					scale_inc_temp = new Double(scale_inc_text.getText() );
					buttonOK.setEnabled(true);
					set_scale_button.setEnabled(true);
				} catch (Exception e) {
					scale_inc_temp = scale_inc;
					buttonOK.setEnabled(false);
					set_scale_button.setEnabled(false);
				}
				//ej definitivt men tecken till användaren
			}
		});
		//set-scale-lyssnare
		set_scale_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//scale accepterar endast positiva int-värden
				
				//mkt viktigt att komma ihåg skillnaden mellan scale-SWT och
				//den som jag själv räknar ut, min och inc är alltid samma
				//för SWT.scale men ändras för min uträknade skala
				//max ändras för användaren och för SWT.scale
				
				double min = scale_min_temp.doubleValue();
				double max = scale_max_temp.doubleValue();
				double inc = scale_inc_temp.doubleValue();
				//om max är mindre än min, eller om increment är större
				//än avståndel mellan min och max sätts ingen ny skala
				//även om inc är 0 eller mindre
				if(max < min || inc > max-min || inc<=0 ){
					//skriver ut gamla värdena, alla kan vara fel och kan ändras
					scale_min_text.setText(scale_min.toString() );
					scale_max_text.setText(scale_max.toString() );
					scale_inc_text.setText(scale_inc.toString() );
				}
				else{
					//räknar ut skalan i formen y=kx+m, där m är min, k är 
					//storlek på steg och scale ger steg om ett som x
					
					//swt-skalans max är antal helsteg som inc behöver för
					//att komma till max
					scale_max_swt=(int)Math.ceil( (max-min)/inc ) ;
					//sätter swt-skalans max
					constant_scale.setMaximum(scale_max_swt );
					System.out.println("scale_max_swt: "+scale_max_swt);
					
					//max sätts till närmsta heltalsvärde i steg om inc
					//från min
					max=Math.ceil( (max-min)/inc )*inc+min;
					System.out.println("max: "+max);
					System.out.println("min: "+min);
					System.out.println("inc: "+inc);
					
					//sparar värdena
					scale_max = new Double(max);
					scale_min=scale_min_temp;
					scale_inc=scale_inc_temp;
					
					//skriver ut värdena, endast max kan ändras
					scale_max_text.setText(scale_max.toString() );
					
					
				}
				
				
				//initierar till min-värdet
				constant_scale.setSelection(0);
				//samma kod som i scale-lyssnaren:
				synchronized(synch_obj){
					constant_val=String.valueOf(constant_scale.getSelection()*scale_inc.doubleValue()+scale_min.doubleValue() );//kx+m
				}
				
				if(GoSim.process!=null && allow_write){//sätt endast värde om sim körs och tråden skrivit värde
					write_file_synch();
				}
				
				//sparar skal_pos, så den är rätt även om man sparar
				//med öppet fönster eller stänger/öppnar nytt fönster
				skal_pos=constant_scale.getSelection();
				
				constant_val_text.setText(constant_val);
				box.uppdatera_area();
				
				
			}
		});
		//OK/Cancel-lyssnare
		buttonOK.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				constant_val=constant_val_temp;
				options_shell.dispose();
			}
		});
		buttonCancel.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//om användaren trycker cancel efter att ändrat fält 1
	        	//men sen ändrar fält två ska inte fält 1 ändras
				constant_val_temp=constant_val;
				scale_min_temp=scale_min;
				scale_max_temp=scale_max;
				scale_inc_temp=scale_inc;
				options_shell.dispose();
			}
		});
		
		


		//script_shell.setSize (200, 200);
		options_shell.setText("Real Time Constant Options");
		options_shell.pack();
		options_shell.open();
		while (!options_shell.isDisposed()) {
			if (!box.display.readAndDispatch())
				box.display.sleep();
		}
		
	}
	
	
	//synkroniserad filskrivning. Skriver fil om ingen fil redan finns.
	//Det betyder att octave läst och raderat filen. Annars skapas en tråd
	//som kollar om fil finns och när den är borta skrivs en fil med värde
	//som är det sista värdet scale gett
	//Detta gör att det sista värdet som scale skapar när ingen fil finns
	//kommer tas med men denna metod
	//är lite långsam men inte jättelångsam.
	//bara en sån här metod åt gången tillåts köra i scalelyssnaren och 
	//konstantvärdet som sätts i scale och skrivs i fil här är synkroniserade
	public void write_file_synch(){
		
		allow_write=false;
		
		System.out.println("write file " );
		
		Thread writer_thread = new Thread(new Runnable() {
            public void run() {
            	boolean file_exists = true;//flagga för om filen finns eller ej
            	//om filen ej finns skapas en ny fil, 

            	//kollar om filen inte raderats än
            	//skapar abstract pathname
            	File file_path = new File(GoSim.global_path+"/temp/");
            	//skapar fil som värdet ska skrivas i och läsas av octave
            	File file = new File(GoSim.global_path+"/temp/RealTimeConstant_"+box.script_name);

            	File file_list1[] = file_path.listFiles();
            	if(file_list1.length>0 ){//om mappen är tom behövs ingen koll
            		while(file_exists && GoSim.process!=null ){//så länge fil finns och sim körs, när sim avslutas töm listan och skriv ut alla värden
            			File file_list[] = file_path.listFiles();
            			if(file_list!=null){
            				for(int i=0; i<file_list.length; i++){
            					if(file_list[i].getPath().equals(file.getPath() ) ){//filen finns, vänta
            						System.out.println("finns" );
            						file_exists=true;
            						break;
            					}
            					else{//filen finns ej, skriv ny fil
            						System.out.println("finns ej" );
            						file_exists=false;
            					}
            				}
            			}
            			if(file_list.length==0){//tom mapp, filen finns inte, skriv ny fil
            				System.out.println("tom mapp, finns ej" );
    						file_exists=false;
            			}
            			try{
        					Thread.sleep(10);//1000 = vänta en sekund
        				}catch(InterruptedException ex){
        				}
            		}
            	}

            	System.out.println("skriver fil" );
            	//filen finns inte, den har raderats lästs och raderats av octave

            	//skriver i filen
            	try{
            		PrintWriter printWriter = new PrintWriter (file);
            		synchronized(synch_obj){
            			printWriter.print (constant_val );
            			allow_write=true;//här i synch så att scale aldrig kan
            			//vara i en position som inte skickats ut
            			//alltså att ett värde väljs och en tråd inte skapas
            		}
            		printWriter.close ();
            	}
            	catch(FileNotFoundException e){
            		allow_write=true;//om nåt skulle gå fel med att skriva filen ska det fortsätta fungera
            		GoSim.text.append("\nFile create/write error, Real Time Constant: " +e + "");
            	}
            	
            	
            	
            }
		});
		
		writer_thread.setDaemon(true);//ingen user thread
    	writer_thread.start();
    	
		
	}
	
	//sker när man dubbelklickar
	public void double_click_action(){
		
		//att öppna options om det stängts en gång och annars använda
		//shell.setActive() fungerar inte, oklart varför. Stänger och startar om
		//om det är öppet.
		
		if(options_shell!=null){//är null om aldrig öppnats
			if(!options_shell.isDisposed() )//öppen, 
				options_shell.dispose();
		}
		
		Display.getDefault().asyncExec(new Runnable() {
			public void run() {
				options();//öppnar GUI:t
			}
		});
		
	}
	
	//körs när simulering startas
	public void sim_start(){
	}

	//körs när simulering stoppas
	public void sim_stop(){

	}
	
	//körs när GoSim stängs
	public void end_gosim_stop(){
		
		//stänger options 
		if(options_shell!=null){//är null om aldrig öppnats
			if(!options_shell.isDisposed() )//öppen
				options_shell.dispose();
		}

	}
	
	//körs när nån funktion skriver sträng med prefix g_s under simulering
	public void sim_update(String str){
		
	}

}
