import java.io.Serializable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedList;
import java.math.MathContext;
import java.math.BigDecimal;




public class Scope implements FunctionIdentity, Serializable{
	
	//för serializable, en flagga för att detektera om man gör
	//stora ändringar i sin klass, inte ett måste men får bort en varning
	private static final long serialVersionUID = 1234L;
			
	Box box=null;
	Integer scope_inputs = new Integer(1); //antal insignaler som denna har, kan väljas mellan 1 och 5
	Integer temp = new Integer(1);//tempvärde används i GUI:t
	
	int scope_inputs_plot=1;//används i många villkor i plotalgoritmen, detta
	//värde ändras bara när man kör en sim så att man inte behöver kolla
	//om användaren ändrar antal insignaler i plotalgoritmen. 
	//bestämmer antal plottar som plottas
	//används även för att ta in signaler, ändras bara vid sim-start så
	//att om man ändrar antal insignaler vid sim fortsätter rätt antal
	//signaler tas in
	
	boolean auto_show_flag = true;//flagga för om ett fönster ska 
	//flyttas längst fram när simulering startas
	boolean XY_plot_flag = false;//flagga för om det ska vara en XY-plot eller
	//ej. true = XY-plot
	int XY_plot_flag_param = 0;//samma som boolean ovan, men int för att kunna
	//skicka som parameter till octave. 0=vanlig plot, 1=XY-plot
	
	//linjetjocklek
	Integer line_width = new Integer(2);
	Integer line_width_temp = new Integer(2);//temp för GUI;
	
	//horisontvariabler:
	boolean horizon_plot_flag = false;//flagga för om användaren valt horisontplot,
	//true = on
	double horizon = 100.0;//horisont, använd .0 för att bli doubleberäkningar
	//och inte int-beräkningar
	Double horizon_temp = new Double(100.0);//tempvärde för GUI
	double horizon_cnt = 0.0;//horisonträknare för horisontalgoritmen, i princip
	//antal horisonter som passerats, går den över den sista horisonten töms
	//datalistorna och räknaren uppdateras
	
	//skalvariabler:
	//flaggor för om skalor är auto eller ej, true = auto, false = manuell
	boolean x_min_auto_flag = true;
	boolean x_max_auto_flag = true;
	boolean y_min_auto_flag = true;
	boolean y_max_auto_flag = true;
	//flagga för om x_max ska vara simuleringsstopptiden
	boolean x_max_sim_stop_flag = false;
	//manuellt satta värden för skalornas max/min
	double x_min_set = 0.0;
	double x_max_set = 0.0;
	double y_min_set = 0.0;
	double y_max_set = 0.0;
	//tempvärden för GUI:t
	double x_min_set_temp = 0.0;
	double x_max_set_temp = 0.0;
	double y_min_set_temp = 0.0;
	double y_max_set_temp = 0.0;
	
	transient Runnable runnable_plot;
	transient Shell plot_shell;//så jag vet om den är öppen
	transient Canvas plot_canvas;//för att kunna uppdatera från runnable
	
	//lista med alla in-listor för att kunna iterera
	transient ArrayList all_in_data = new ArrayList();
	
	//x och y1-5 för graf1, sparas ej (transient)
	//ej synkroniserade med realtidsplotten, de kopieras i realtidsplotten
	//i varje sampel
	transient ArrayList data_x_in = new ArrayList();
	transient ArrayList data_y1_in = new ArrayList();
	transient ArrayList data_y2_in = new ArrayList();
	transient ArrayList data_y3_in = new ArrayList();
	transient ArrayList data_y4_in = new ArrayList();
	transient ArrayList data_y5_in = new ArrayList();
	
	
	
	//constructor
	public Scope(int x,int y, Display display_in, Shell sh, Canvas ca){
		
		box = new Box(x, y, display_in, sh, ca);
		box.set_number_inputs(1);
		box.set_number_outputs(0);
		box.create_menu();//måste vara efter set_inputs/outputs eftersom menyn behöver deras värden
		box.set_height_and_width(45,45);
		box.set_title("Scope");
		box.set_function_type(2);
		box.set_FunctionIdentity(this);
		
		//lägger inlistorna i en lista
		all_in_data.add(data_x_in);
		all_in_data.add(data_y1_in);
		all_in_data.add(data_y2_in);
		all_in_data.add(data_y3_in);
		all_in_data.add(data_y4_in);
		all_in_data.add(data_y5_in);
		
	}
	
	//ritar detta blocks utseende i boxen
	public void draw_graphics(){
		box.gc.setLineWidth(2);
		box.gc.drawRectangle(box.x_start+5, box.y_start+8, box.width-10, 17);
		if(XY_plot_flag){
			Font font = new Font( box.display, new FontData( "Arial", 10, SWT.BOLD ) ); //namn, storlek, tjock/normal/kursiv
			box.gc.setFont(font);
			box.gc.drawText("X", box.x_start+8, box.y_start+7, true); //true gör att ingen bakgrund ritas bakom texten
			box.gc.drawText("Y", box.x_start+8, box.y_start+25, true); //true gör att ingen bakgrund ritas bakom texten
			font.dispose();
		}
		else		
			box.gc.drawLine(box.x_start+9, box.y_start+35, box.x_end-10, box.y_start+35);
	}
	
		//ger boxen detta funktionsobjekt sitter i
	public Box get_box(){
		return box;
	}
		
	//kopierar interfacet som instansierats som Add..nåt sånt...
	//blir en kopia iaf
	public FunctionIdentity copy(int x,int y, Display display_in, Shell sh, Canvas ca){
		return new Scope(x, y, display_in, sh, ca);
	}
	
	//ger strängen som ska skrivas för funktionen i skriptet
	public String get_function(){
		return "Scope";
	}
	
	//ger parametrar som användaren sätter för funktionen
	public String[] get_parameters(){
		return new String[]{"=" + scope_inputs.toString() + ";\n", "="+XY_plot_flag_param + ";\n"};
	}
	
	//sträng som skrivs före loopen, "" gör att inget skrivs
	public String get_pre_loop_string(){
		return "";//pkg load control; %GoSim Control\n";
	}

	//sträng som skrivs efter loopen, "" gör att inget skrivs
	public String get_post_loop_string(){
		return "";
	}
	
	
	//GUI:t
	public void options(){
		final Shell options_shell = new Shell(this.box.display.getActiveShell(), SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		GridLayout grid_layout = new GridLayout();
		options_shell.setLayout(grid_layout);
		grid_layout.numColumns = 2;
		grid_layout.makeColumnsEqualWidth=true;



		//info-Text
		Text info_text = new Text(options_shell,SWT.READ_ONLY  | SWT.MULTI  | SWT.WRAP);// | SWT.V_SCROLL); //SWT.NULL);
		Font font = new Font( box.display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		info_text.setFont(font);
		info_text.setBackground(box.display.getSystemColor(SWT.COLOR_WIDGET_BACKGROUND));
		info_text.setText("Scope plots up to 5 signals or is " +
				"a XY graph in real time. Having one or several plot windows open " +
				"significantly slows down the simulation. Synchronization is " +
				"poor when the simulation time is short.\n\n" +
				"Choosing auto show will move the plot to the front " +
				"when the simulation starts if the scope is open.\n\n" +
				"Horizon plot means that the plot will only show a certain " +
				"interval in x. After the horizon value the plot restarts. A " +
				"horizon value of 100 will show data from 0, 100, 200... with " +
				"data before the last horizon deleted.\n" +
				"In a XY plot the horizon operates on the x value but it " +
				"doesn't make much sense here.\n" +
				"The last horizon is always shown at the end of the " +
				"simulation.\n\n" +
				"The scale selections here are not affected by 'reset' in the " +
				"plot area. The reset button only affects the zoom, move " +
				"and freeze functions.\n");
		GridData info_text_grid_data= new GridData();
		info_text_grid_data.horizontalSpan = 2;
		//info_label_grid_data.heightHint = 700;
		info_text_grid_data.widthHint = 700;
		info_text.setLayoutData(info_text_grid_data);

		
		//Label
		Label label = new Label(options_shell, SWT.NULL);
		label.setFont(font);
		label.setText("Number of inputs, 1 to 5:");

		//------TEXTFÄLT
		//tar in siffor till sampeltid och stop
		final Text var1_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		var1_text.setFont(font);
		var1_text.setFocus();
		var1_text.setText(scope_inputs.toString() );
		var1_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		var1_text.setEnabled(!XY_plot_flag );

		GridData text_grid_data1 = new GridData();
		text_grid_data1.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		text_grid_data1.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		var1_text.setLayoutData(text_grid_data1);
		
		//XY-plot-knapp
		final Button XY_plot_button = new Button(options_shell, SWT.CHECK);
		XY_plot_button.setFont(font);
		XY_plot_button.setText("XY plot");
		XY_plot_button.setSelection(XY_plot_flag);
		GridData XY_plot_grid_data= new GridData();
		//auto_show_grid_data.verticalAlignment = GridData.FILL;
		XY_plot_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		//buttonOK_grid_data.horizontalAlignment = GridData.FILL;
		//buttonOK_grid_data.grabExcessHorizontalSpace = true;
		//buttonOK_grid_data.heightHint = 30;
		//buttonOK_grid_data.widthHint = 500;
		XY_plot_button.setLayoutData(XY_plot_grid_data);
		
		//auto-show-knapp
		final Button auto_show_button = new Button(options_shell, SWT.CHECK);
		auto_show_button.setFont(font);
		auto_show_button.setText("Auto show");
		auto_show_button.setSelection(auto_show_flag);
		GridData auto_show_grid_data= new GridData();
		//auto_show_grid_data.verticalAlignment = GridData.FILL;
		auto_show_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		//buttonOK_grid_data.horizontalAlignment = GridData.FILL;
		//buttonOK_grid_data.grabExcessHorizontalSpace = true;
		//buttonOK_grid_data.heightHint = 30;
		//buttonOK_grid_data.widthHint = 500;
		auto_show_button.setLayoutData(auto_show_grid_data);
		
		//linjetjocklek-Label
		Label line_thickness_label = new Label(options_shell, SWT.NULL);
		line_thickness_label.setFont(font);
		line_thickness_label.setText("Line thickness, 1, 2, 3, 4... :");
		
		//tar in siffor linjetjocklek
		final Text line_thickness_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		line_thickness_text.setFont(font);
		line_thickness_text.setText(line_width.toString() );
		line_thickness_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));

		GridData line_thickness_text_grid_data = new GridData();
		line_thickness_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		line_thickness_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		line_thickness_text.setLayoutData(line_thickness_text_grid_data);
		
		//horisont-knapp
		final Button horizon_button = new Button(options_shell, SWT.CHECK);
		horizon_button.setFont(font);
		horizon_button.setText("Horizon plot, horizon (sec):");
		horizon_button.setSelection(horizon_plot_flag);
		
		//horisontvärde
		final Text horizon_value_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		horizon_value_text.setFont(font);
		horizon_value_text.setText(String.valueOf(horizon) );
		horizon_value_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		horizon_value_text.setEnabled(horizon_plot_flag );
		GridData horizon_value_text_grid_data = new GridData();
		horizon_value_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		horizon_value_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		horizon_value_text.setLayoutData(horizon_value_text_grid_data);
		
		//x-min-label
		Label x_min_label = new Label(options_shell, SWT.NULL);
		x_min_label.setFont(font);
		x_min_label.setText("X min: ");
		GridData x_min_label_grid_data = new GridData();
		x_min_label_grid_data.verticalAlignment = GridData.CENTER;
		x_min_label_grid_data.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		x_min_label_grid_data.horizontalAlignment = GridData.END;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		x_min_label.setLayoutData(x_min_label_grid_data);
		
		//x-min-knapp
		final Button x_min_button = new Button(options_shell, SWT.CHECK);
		x_min_button.setFont(font);
		x_min_button.setText("Auto");
		x_min_button.setSelection(x_min_auto_flag);
		
		//x-min, manuellt värde
		final Text x_min_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//t1.setTabs(10);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		x_min_text.setFont(font);
		x_min_text.setText(String.valueOf(x_min_set) );
		x_min_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		x_min_text.setEnabled(!x_min_auto_flag);
		GridData x_min_text_grid_data = new GridData();
		x_min_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		x_min_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		x_min_text.setLayoutData(x_min_text_grid_data);
		
		//x-max-label
		Label x_max_label = new Label(options_shell, SWT.NULL);
		x_max_label.setFont(font);
		x_max_label.setText("X max: ");
		GridData x_max_label_grid_data = new GridData();
		x_max_label_grid_data.verticalAlignment = GridData.CENTER;
		x_max_label_grid_data.verticalSpan = 3;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		x_max_label_grid_data.horizontalAlignment = GridData.END;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		x_max_label.setLayoutData(x_max_label_grid_data);

		//x-max-knapp
		final Button x_max_button = new Button(options_shell, SWT.CHECK);
		x_max_button.setFont(font);
		x_max_button.setText("Auto");
		x_max_button.setSelection(x_max_auto_flag);
		
		//x-max-sim-stop-knapp
		final Button x_max_sim_stop_button = new Button(options_shell, SWT.CHECK);
		x_max_sim_stop_button.setFont(font);
		x_max_sim_stop_button.setText("Simulation stop time");
		x_max_sim_stop_button.setSelection(x_max_sim_stop_flag);

		//x-max, manuellt värde
		final Text x_max_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//t1.setTabs(10);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		x_max_text.setFont(font);
		x_max_text.setText(String.valueOf(x_max_set) );
		x_max_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		x_max_text.setEnabled(!(x_max_auto_flag || x_max_sim_stop_flag) );
		GridData x_max_text_grid_data = new GridData();
		x_max_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		x_max_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		x_max_text.setLayoutData(x_max_text_grid_data);
		
		
		//y-min-label
		Label y_min_label = new Label(options_shell, SWT.NULL);
		y_min_label.setFont(font);
		y_min_label.setText("Y min: ");
		GridData y_min_label_grid_data = new GridData();
		y_min_label_grid_data.verticalAlignment = GridData.CENTER;
		y_min_label_grid_data.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		y_min_label_grid_data.horizontalAlignment = GridData.END;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		y_min_label.setLayoutData(y_min_label_grid_data);

		//y-min-knapp
		final Button y_min_button = new Button(options_shell, SWT.CHECK);
		y_min_button.setFont(font);
		y_min_button.setText("Auto");
		y_min_button.setSelection(y_min_auto_flag);

		//y-min, manuellt värde
		final Text y_min_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		y_min_text.setFont(font);
		y_min_text.setText(String.valueOf(y_min_set) );
		y_min_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		y_min_text.setEnabled(!y_min_auto_flag);
		GridData y_min_text_grid_data = new GridData();
		y_min_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		y_min_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		y_min_text.setLayoutData(y_min_text_grid_data);

		//y-max-label
		Label y_max_label = new Label(options_shell, SWT.NULL);
		y_max_label.setFont(font);
		y_max_label.setText("Y max: ");
		GridData y_max_label_grid_data = new GridData();
		y_max_label_grid_data.verticalAlignment = GridData.CENTER;
		y_max_label_grid_data.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		y_max_label_grid_data.horizontalAlignment = GridData.END;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		y_max_label.setLayoutData(y_max_label_grid_data);

		//y-max-knapp
		final Button y_max_button = new Button(options_shell, SWT.CHECK);
		y_max_button.setFont(font);
		y_max_button.setText("Auto");
		y_max_button.setSelection(y_max_auto_flag);

		//y-max, manuellt värde
		final Text y_max_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		y_max_text.setFont(font);
		y_max_text.setText(String.valueOf(y_max_set) );
		y_max_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));
		y_max_text.setEnabled(!y_max_auto_flag);
		GridData y_max_text_grid_data = new GridData();
		y_max_text_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		y_max_text_grid_data.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		y_max_text.setLayoutData(y_max_text_grid_data);

				
		//KNAPPAR
		final Button buttonOK = new Button(options_shell, SWT.PUSH);
		buttonOK.setFont(font);
		buttonOK.setText("Ok");
		GridData buttonOK_grid_data= new GridData();
		buttonOK_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		buttonOK_grid_data.horizontalAlignment = GridData.FILL;
		//buttonOK_grid_data.grabExcessHorizontalSpace = true;
		//buttonOK_grid_data.heightHint = 30;
		//buttonOK_grid_data.widthHint = 500;
		buttonOK.setLayoutData(buttonOK_grid_data);

		Button buttonCancel = new Button(options_shell, SWT.PUSH);
		buttonCancel.setFont(font);
		buttonCancel.setText("Cancel");
		buttonCancel.setLayoutData(buttonOK_grid_data);

		//LYSSNARE
		//antal insignaler till scope
		var1_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					temp = new Integer(var1_text.getText());
					buttonOK.setEnabled(true);
				} catch (Exception e) {
					temp = scope_inputs;//för om nån autoknapp aktiverar OK när denna ruta är fel ifylld
					buttonOK.setEnabled(false);
				}
			}
		});
		//XY-plot_knappen
		XY_plot_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//av/aktiverar värdesrutan för antal insignaler
				var1_text.setEnabled(!XY_plot_button.getSelection() );
				

				//sätter scope_inputs till godtyckligt tal som inte är
				// samma som temp och temp till 1 så if-satsen för 
				//insignalval blir aktivt om man avaktiverar XY-plot
				if(!XY_plot_button.getSelection() ){
					scope_inputs = new Integer(30);
					temp = new Integer(1);//blocket sätts till 1 insignal
					
					//antal-insignal-rutan sätts till 1 som är värdet
					//som den återgår till när man avbockar XY-plot
					var1_text.setText("1");
				}
			}
		});
		//linjetjocklek-värdet
		line_thickness_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					line_width_temp = new Integer(line_thickness_text.getText() );
					buttonOK.setEnabled(true);
				} catch (Exception e) {
					line_width_temp = line_width;
					buttonOK.setEnabled(false);
				}
				//får inte vara lika eller mindre än noll, detta är ändå 
				//ingen definitiv kontroll men ett tecken till användaren
				if(line_width_temp.intValue()<=0)
					buttonOK.setEnabled(false);
			}
		});
		//horisontknappen:
		horizon_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//av/aktiverar horisontvärdesrutan
				horizon_value_text.setEnabled(horizon_button.getSelection() );
			}
		});
		//horisontvärdet
		horizon_value_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					horizon_temp = new Double(horizon_value_text.getText() );
					buttonOK.setEnabled(true);
				} catch (Exception e) {
					horizon_temp = new Double(horizon);
					buttonOK.setEnabled(false);
				}
				//får inte vara lika eller mindre än noll, detta är ändå 
				//ingen definitiv kontroll men ett tecken till användaren
				if(horizon_temp.doubleValue()<=0)
					buttonOK.setEnabled(false);
			}
		});
		//x-min-knappen
		x_min_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//av/aktiverar x-min-värdesrutan
				x_min_text.setEnabled(!x_min_button.getSelection() );
				
				//textrutan kan avaktivera OK så aktiverar den när denna är 
				//ibockad
				if(x_min_button.getSelection() )
					buttonOK.setEnabled(true);
			}
		});
		//x-max-knappen
		x_max_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//av/aktiverar x-min-värdesrutan
				x_max_text.setEnabled( !(x_max_button.getSelection() || x_max_sim_stop_button.getSelection()) );
				//avaktiverar x_max_sim_stop om denna blir ibockad
				if(x_max_button.getSelection() )
					x_max_sim_stop_button.setSelection(false);
				
				//textrutan kan avaktivera OK så aktiverar den när denna är 
				//ibockad
				if(x_max_button.getSelection() )
					buttonOK.setEnabled(true);
			}
		});
		//x_max_sim_stop_button-lyssnare
		x_max_sim_stop_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//av/aktiverar x-min-värdesrutan
				x_max_text.setEnabled( !(x_max_button.getSelection() || x_max_sim_stop_button.getSelection()) );
				//avaktiverar x_max_auto om denna blir ibockad
				if(x_max_sim_stop_button.getSelection() )
					x_max_button.setSelection(false);
								
				//textrutan kan avaktivera OK så aktiverar den när denna är 
				//ibockad
				if(x_max_sim_stop_button.getSelection() )
					buttonOK.setEnabled(true);
			}
		});
		//y-min-knappen
		y_min_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//av/aktiverar x-min-värdesrutan
				y_min_text.setEnabled(!y_min_button.getSelection() );
				
				//textrutan kan avaktivera OK så aktiverar den när denna är 
				//ibockad
				if(y_min_button.getSelection() )
					buttonOK.setEnabled(true);
			}
		});
		//y-max-knappen
		y_max_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//av/aktiverar x-min-värdesrutan
				y_max_text.setEnabled(!y_max_button.getSelection() );
				
				//textrutan kan avaktivera OK så aktiverar den när denna är 
				//ibockad
				if(y_max_button.getSelection() )
					buttonOK.setEnabled(true);
			}
		});
		//x-min-värdet
		x_min_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					x_min_set_temp = new Double(x_min_text.getText() ).doubleValue();
					buttonOK.setEnabled(true);
				} catch (Exception e) {
					x_min_set_temp = x_min_set;
					buttonOK.setEnabled(false);
				}
				//detta är ingen definitiv kontroll men ett tecken till användaren
			}
		});
		//x-max-värdet
		x_max_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					x_max_set_temp = new Double(x_max_text.getText() ).doubleValue();
					buttonOK.setEnabled(true);
				} catch (Exception e) {
					x_max_set_temp = x_max_set;
					buttonOK.setEnabled(false);
				}
				//detta är ingen definitiv kontroll men ett tecken till användaren
			}
		});
		//y-min-värdet
		y_min_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					y_min_set_temp = new Double(y_min_text.getText() ).doubleValue();
					buttonOK.setEnabled(true);
				} catch (Exception e) {
					y_min_set_temp = y_min_set;
					buttonOK.setEnabled(false);
				}
				//detta är ingen definitiv kontroll men ett tecken till användaren
			}
		});
		//y-max-värdet
		y_max_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				try {
					y_max_set_temp = new Double(y_max_text.getText() ).doubleValue();
					buttonOK.setEnabled(true);
				} catch (Exception e) {
					y_max_set_temp = y_max_set;
					buttonOK.setEnabled(false);
				}
				//detta är ingen definitiv kontroll men ett tecken till användaren
			}
		});
		
		buttonOK.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//kan inte ändra antal signaler eller toggla XY-plot om
				//osynlig linje kopplad
				if(box.is_invisible_line_connected() ){
					GoSim.text.append("\nError: Can't change number of signals " +
							"or toggle XY-plot " +
							"when invisible lines are connected. " +
							"Please make invisible lines visible " +
							"before changing number of signals or " +
							"toggling XY-plot " +
							"and then make them invisible again.");
					
					temp = scope_inputs;//om den har ändrats och man inte ändrar nästa gång men trycker OK
				}
				else {//ingen osynlig kopplad
					//flagga för XY-plot
					XY_plot_flag = XY_plot_button.getSelection();
					//om XY-plot valts sätts antal insignaler till 2, scope_inputs
					//sätts till 1 för att ta in 2 värden (x och y) och 
					//XY_plot_flag_param sätts till 1
					if(XY_plot_flag){//valt XY-plot
						XY_plot_flag_param=1;
						scope_inputs = new Integer(1);//för plotalgoritmen
						if(box.number_inputs != 2){
							box.disconnect_all_lines();//linjens position ändras och försvinner beroende på val
							box.uppdatera_area();
							box.set_number_inputs(2);
							box.set_height_and_width(45,45);
						}
						box.uppdatera_area();//grafiken ska uppdateras för att visa
						//x,y även om det var 2 insignaler för vanlig scope
					}
					else{
						XY_plot_flag_param=0;
					}

					//disconnecta osv bara om antal insignaler ändras
					//inte gå in här om det är XY-plot
					if(scope_inputs.intValue() != temp.intValue() && !XY_plot_flag ){
						scope_inputs=temp;
						if(temp.intValue()>5)//om användaren skriver i fel värden
							scope_inputs=new Integer(5);
						if(temp.intValue()<1)
							scope_inputs=new Integer(1);
						//ändrar boxens antal insignaler och storlek
						box.disconnect_all_lines();//linjens position ändras och försvinner beroende på val
						box.uppdatera_area();
						if(scope_inputs.intValue()==1){
							box.set_number_inputs(1);
							box.set_height_and_width(45,45);
						}
						else if(scope_inputs.intValue()==2){
							box.set_number_inputs(2);
							box.set_height_and_width(45,45);
						}
						else if(scope_inputs.intValue()==3){
							box.set_number_inputs(3);
							box.set_height_and_width(60,45);
						}
						else if(scope_inputs.intValue()==4){
							box.set_number_inputs(4);
							box.set_height_and_width(90,45);
						}
						else if(scope_inputs.intValue()==5){
							box.set_number_inputs(5);
							box.set_height_and_width(90,45);
						}

						box.uppdatera_area();
					}

				}


				auto_show_flag = auto_show_button.getSelection();

				//horisont
				horizon_plot_flag = horizon_button.getSelection();
				//horisonten måste vara större än noll, annars behåll gamla värdet
				if(horizon_temp.doubleValue()>0)
					horizon = horizon_temp.doubleValue();
				//om man ändrar horisontvärdet mitt under sim måste horisonträknaren
				//få rätt värde. Sker om:
				//kör process
				//finns i simlistan
				//x-listan är större än 0 (listan clearas vid horisontinläsning, liten risk men ändå)
				//fönstret öppnats en gång (sätter ett värde i x)
				if(plot_shell!=null && GoSim.process!=null && GoSim.script_sim.sim_box_list.contains(box) && data_x_in.size()>0 ){
					//tar fram sista x-värdet
					double x = ((Double)data_x_in.get(data_x_in.size()-1) ).doubleValue();
					horizon_cnt = Math.floor(x/horizon);
				}
				
				//skalor:
				x_min_auto_flag = x_min_button.getSelection();
				x_max_auto_flag = x_max_button.getSelection();
				y_min_auto_flag = y_min_button.getSelection();
				y_max_auto_flag = y_max_button.getSelection();
				x_min_set = x_min_set_temp;
				x_max_set = x_max_set_temp;
				y_min_set = y_min_set_temp;
				y_max_set = y_max_set_temp;
				//x_max_sim_stop sätter x_max till sim stop,
				//om aktiv sätter den x_max-värdet
				x_max_sim_stop_flag = x_max_sim_stop_button.getSelection();
				if(x_max_sim_stop_flag)
					x_max_set=Double.valueOf(GoSim.stop_time ).doubleValue();
				//om båda är manuella måste min vara mindre än max, annars
				//sätts de till auto
				if(!x_min_auto_flag && ( !x_max_auto_flag || x_max_sim_stop_flag) ){//helt manuell skala eller x-max satt till sim-stop (vilket också är manuellt)
					if(x_min_set>x_max_set){//plotalgoritmen kan hantera =
						x_min_auto_flag = true;
						x_max_auto_flag = true;
					}
				}
				if(!y_min_auto_flag && !y_max_auto_flag ){//helt manuell skala
					if(y_min_set>y_max_set){//plotalgoritmen kan hantera =
						y_min_auto_flag = true;
						y_max_auto_flag = true;
					}
				}
				
				//linjetjocklek
				line_width=line_width_temp;
				//får inte vara <=0, sätts då till 3
				if(line_width.intValue() <= 0)
					line_width = new Integer(2);
				
				//ändrade skalor/linjetjocklek kräver att plotten ritas om, om 
				//fönstret är öppet
				//är null om aldrig öppnats
				if( plot_shell!=null && !plot_shell.isDisposed()  )
					plot_canvas.redraw();
				

				options_shell.dispose();

			}
		});
		buttonCancel.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//om man trycker cancel men fått igenom ett värde och
				//inte ändrar nästa gång så ändras detta värde om det inte
				//återställs
				temp = scope_inputs;
				horizon_temp = new Double(horizon);
				x_min_set_temp = x_min_set;
				x_max_set_temp = x_max_set;
				y_min_set_temp = y_min_set;
				y_max_set_temp = y_max_set;
				line_width_temp=line_width;
				
				options_shell.dispose();
			}
		});


		//script_shell.setSize (200, 200);
		options_shell.setText("Scope Options");
		options_shell.pack();
		options_shell.open();
		while (!options_shell.isDisposed()) {
			if (!box.display.readAndDispatch())
				box.display.sleep();
		}
		
	}
	
	//sker när man dubbelklickar
	public void double_click_action(){
		
		try{//plot_shell är null första gången man klickar
			if(!plot_shell.isDisposed() )//öppen
				plot_shell.setActive();
			else{//stängd
				Display.getDefault().asyncExec(new Runnable() {
        			public void run() {
        				plot_GUI();
        			}
        		});
			}
		}
		catch(Exception e){ //stängd
			Display.getDefault().asyncExec(new Runnable() {
    			public void run() {
    				plot_GUI();
    			}
    		});
		}


		System.out.println("efter plot_GUI");
		
		
		
		runnable_plot = new Runnable() {
			public void run() {
				System.out.println("plot tråd start");
				if(plot_canvas!=null){//är null om aldrig öppnats
					if(!plot_canvas.isDisposed()){
						plot_canvas.redraw();
						plot_canvas.update();//så att jag kan pausa här nedan när den ritat klart
					}
				}
				
				//för mycket paus är dåligt, lite paus är bra
				//har man flera fönster öppna blir det mer paus (denna paus/fönster)
				//detta pausar även while-loopen? men jag testade att ta bort det där...?
				//progressbar är så sällan så lite paus gör inget och är bra
				try{//att vänta lite gör att GUI:t inte blir segt och CPU:n avlastas lite, plottar nästan lika snabbt, ger även CPU-kraft atill att läsa in datan vilket gör att octave får några procent mer (beror på antal cpu-kärnor) och sim riskeras inte att bli hindrat (blir lite hindrat, men mkt mindre)
					Thread.sleep(15);//1000 = vänta en sekund
				}catch(InterruptedException ex){
				}

				System.out.println("plot tråd väntar");

				//plotten körs om fönstret är öppet och
				//startar plotten om sim körs
				//om man lägger till en plot under sim och dubbelklickar ska
				//den inte starta
				//inga scopes som ej är kopplade ska starta
				//kollar att den är i sim-listan
				if(plot_shell!=null){//är null om aldrig öppnats
					if(!plot_shell.isDisposed() && GoSim.process!=null && GoSim.script_sim.sim_box_list.contains(box)){
						box.display.asyncExec(this);//lägger i GUI-kön, blir en loop
					}
				}

			}
		};

		box.display.asyncExec(runnable_plot);//lägger i GUI-kön



		


	}
	
	//skapar plotten och kanske GUI till 
	public void plot_GUI(){
		//används för att visa max/min i data_canvas
		final double max_x_show[]={0};
		final double min_x_show[]={0};
		final double max_y_show[]={0};
		final double min_y_show[]={0};
		
		final int zoom_flag[]={-1};//flagga för olika sorts zoom
		//-1: ingen zoom
		//0: kvadratisk zoom
		//1: horisontell zoom
		//2: vertikal zoom
		
		final boolean zoom_square_flag[]={false};//flagga om rutan för zoom ska ritas
		//false: inget sker
		//true: rita ruta för zoom
		
		final int activate_zoom_flag[]={-1};//flagga för olika sorts zoom som
		//aktiveras i algoritmen
		//-1: inget aktivt
		//0: kvadratisk/horisontell/vertikal zoom
		//1: zoom in
		//2: zoom out
		//3: behåll zoomad max/min, annars uppdateras den jämt och 
		//t.ex. förstorar jämt när den funktionen är aktiv varje gång
		//canvasen uppdateras, används av alla zoomfunktioner
		//4: flytta vänster
		//5: flytta höger
		//6: flytta upp
		//7: flytta ner
		
		
		//2: aktivera nya max/min-värden för skalan i plotalgoritmen
		
		plot_shell = new Shell(box.display);
		
		GridLayout grid_layout = new GridLayout();
		plot_shell.setLayout(grid_layout);
		grid_layout.numColumns = 12;
		grid_layout.makeColumnsEqualWidth=false;
		grid_layout.horizontalSpacing=2;
		//grid_layout.verticalSpacing=2;
		
		Font font = new Font( box.display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		
		//horisontell zoom-KNAPP
		final Button horizontal_zoom_button = new Button(plot_shell, SWT.TOGGLE);
		horizontal_zoom_button.setFont(font);
		horizontal_zoom_button.setText("⇆");
		horizontal_zoom_button.setToolTipText("Horizontal Zoom");
		GridData horizontal_zoom_button_grid_data= new GridData();
		horizontal_zoom_button_grid_data.heightHint = 30;
		horizontal_zoom_button.setLayoutData(horizontal_zoom_button_grid_data);
		
		//vertikal zoom-KNAPP
		final Button vertical_zoom_button = new Button(plot_shell, SWT.TOGGLE);
		vertical_zoom_button.setFont(font);
		vertical_zoom_button.setText("⇅");
		vertical_zoom_button.setToolTipText("Vertical Zoom");
		GridData vertical_zoom_button_grid_data= new GridData();
		vertical_zoom_button_grid_data.heightHint = 30;
		vertical_zoom_button.setLayoutData(vertical_zoom_button_grid_data);

		//kvadratisk zoom-KNAPP
		final Button square_zoom_button = new Button(plot_shell, SWT.TOGGLE);
		square_zoom_button.setFont(font);
		square_zoom_button.setText("⇱ ⇲");
		square_zoom_button.setToolTipText("Rectangular Zoom");
		GridData square_zoom_button_grid_data= new GridData();
		square_zoom_button_grid_data.heightHint = 30;
		square_zoom_button.setLayoutData(square_zoom_button_grid_data);
		
		//zooma in-KNAPP
		final Button zoom_in_button = new Button(plot_shell, SWT.PUSH);
		zoom_in_button.setFont(font);
		zoom_in_button.setText("Z+");
		zoom_in_button.setToolTipText("Zoom In");
		GridData zoom_in_button_grid_data= new GridData();
		zoom_in_button_grid_data.heightHint = 30;
		zoom_in_button.setLayoutData(zoom_in_button_grid_data);

		//zooma ut-KNAPP
		final Button zoom_out_button = new Button(plot_shell, SWT.PUSH);
		zoom_out_button.setFont(font);
		zoom_out_button.setText("Z-");
		zoom_out_button.setToolTipText("Zoom Out");
		GridData zoom_out_button_grid_data= new GridData();
		zoom_out_button_grid_data.heightHint = 30;
		zoom_out_button.setLayoutData(zoom_out_button_grid_data);
		
		//flytta vänster-KNAPP
		final Button move_left_button = new Button(plot_shell, SWT.PUSH);
		move_left_button.setFont(font);
		move_left_button.setText("🡄");
		move_left_button.setToolTipText("Move Left");
		GridData move_left_button_grid_data= new GridData();
		move_left_button_grid_data.heightHint = 30;
		move_left_button.setLayoutData(move_left_button_grid_data);
		
		//flytta höger-KNAPP
		final Button move_right_button = new Button(plot_shell, SWT.PUSH);
		move_right_button.setFont(font);
		move_right_button.setText("🡆");
		move_right_button.setToolTipText("Move Right");
		GridData move_right_button_grid_data= new GridData();
		move_right_button_grid_data.heightHint = 30;
		move_right_button.setLayoutData(move_right_button_grid_data);

		//flytta upp-KNAPP
		final Button move_up_button = new Button(plot_shell, SWT.PUSH);
		move_up_button.setFont(font);
		move_up_button.setText("🡅");
		move_up_button.setToolTipText("Move Up");
		GridData move_up_button_grid_data= new GridData();
		move_up_button_grid_data.heightHint = 30;
		move_up_button.setLayoutData(move_up_button_grid_data);

		//flytta ner-KNAPP
		final Button move_down_button = new Button(plot_shell, SWT.PUSH);
		move_down_button.setFont(font);
		move_down_button.setText("🡇");
		move_down_button.setToolTipText("Move Down");
		GridData move_down_button_grid_data= new GridData();
		move_down_button_grid_data.heightHint = 30;
		move_down_button.setLayoutData(move_down_button_grid_data);
		
		//freeze-KNAPP
		final Button freeze_button = new Button(plot_shell, SWT.PUSH);
		freeze_button.setFont(font);
		freeze_button.setText("⬛");
		freeze_button.setToolTipText("Freeze Axes");
		GridData freeze_button_grid_data= new GridData();
		freeze_button_grid_data.heightHint = 30;
		freeze_button.setLayoutData(freeze_button_grid_data);
		
		//återställ-KNAPP
		final Button reset_button = new Button(plot_shell, SWT.PUSH);
		reset_button.setFont(font);
		reset_button.setText("Reset");
		reset_button.setToolTipText("Reset Zoom, Move and Freeze");
		GridData reset_button_grid_data= new GridData();
		reset_button_grid_data.heightHint = 30;
		reset_button.setLayoutData(reset_button_grid_data);
		
		//OPTIONS-KNAPP
		final Button options_button = new Button(plot_shell, SWT.PUSH);
		options_button.setFont(font);
		options_button.setText("Options");
		options_button.setToolTipText("Options");
		font.dispose();
		GridData options_button_grid_data= new GridData();
		//options_button_grid_data.verticalAlignment = GridData.BEGINNING;
		//gridData2.verticalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		//options_button_grid_data.horizontalAlignment = GridData.FILL;
		//buttonOK_grid_data.grabExcessHorizontalSpace = true;
		options_button_grid_data.heightHint = 30;
		//buttonOK_grid_data.widthHint = 500;
		options_button.setLayoutData(options_button_grid_data);
		
		//horisontell, vertikal, rektangulär zoom-lyssnare
		horizontal_zoom_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				horizontal_zoom_button.setSelection(horizontal_zoom_button.getSelection() );
				vertical_zoom_button.setSelection(false);
				square_zoom_button.setSelection(false);
				if(horizontal_zoom_button.getSelection() )
					zoom_flag[0]=1;
				else
					zoom_flag[0]=-1;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
			}
		});
		vertical_zoom_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				horizontal_zoom_button.setSelection(false);
				vertical_zoom_button.setSelection(vertical_zoom_button.getSelection() );
				square_zoom_button.setSelection(false);
				if(vertical_zoom_button.getSelection() )
					zoom_flag[0]=2;
				else
					zoom_flag[0]=-1;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
			}
		});
		square_zoom_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				horizontal_zoom_button.setSelection(false);
				vertical_zoom_button.setSelection(false);
				square_zoom_button.setSelection(square_zoom_button.getSelection() );
				if(square_zoom_button.getSelection() )
					zoom_flag[0]=0;
				else
					zoom_flag[0]=-1;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
			}
		});
		//zoom in/out-lyssnare
		zoom_in_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				activate_zoom_flag[0]=1;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
				//utför även själva zoomen
			}
		});
		zoom_out_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				activate_zoom_flag[0]=2;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
				//utför även själva zoomen
			}
		});
		//move-lyssnare
		move_left_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				activate_zoom_flag[0]=4;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
				//utför även själva zoomen
			}
		});
		move_right_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				activate_zoom_flag[0]=5;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
				//utför även själva zoomen
			}
		});
		move_up_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				activate_zoom_flag[0]=6;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
				//utför även själva zoomen
			}
		});
		move_down_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				activate_zoom_flag[0]=7;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
				//utför även själva zoomen
			}
		});
		//freeze-lyssnare
		freeze_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				activate_zoom_flag[0]=3;
				zoom_square_flag[0]=false;//avaktiverar zoomning om det är aktivt
				plot_canvas.redraw();//tar bort zoomruta om en ritas
				//utför även själva zoomen
			}
		});
		//reset-lyssnare
		reset_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//avaktiverar zoomning om det är aktivt
				activate_zoom_flag[0]=-1;
				//ingen ruta ska ritas om en hålls på att ritas
				zoom_square_flag[0]=false;
				plot_canvas.redraw();//tar bort zoomruta om en ritas
			}
		});		
		//lyssnare-options
		options_button.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				options();
				
				//avaktiverar zoomning om det är aktivt
				zoom_square_flag[0]=false;
				plot_canvas.redraw();//tar bort zoomruta om en ritas
			}
		});
		
		
		
		//canvas med namn på signaler och max/min-värde
		final Canvas data_canvas = new Canvas(plot_shell,SWT.NO_REDRAW_RESIZE);
		data_canvas.setFocus();
		GridData data_canvas_grid_data = new GridData();
		data_canvas_grid_data.verticalAlignment = GridData.FILL;
		data_canvas_grid_data.horizontalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		data_canvas_grid_data.horizontalSpan = 12;
		//data_canvas_grid_data.grabExcessVerticalSpace = true;
		//data_canvas_grid_data.grabExcessHorizontalSpace = true;
		data_canvas_grid_data.heightHint = 55;
		//plot_canvas_grid_data.widthHint = 500;
		data_canvas.setLayoutData(data_canvas_grid_data);
		
		//värdepunkter för där pekaren är som skrivs ut när man rör musen
		final double x_coord_val[]={0};
		final double y_coord_val[]={0};

		//data_canvas lyssnare
		data_canvas.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
				
				//skriver ut max/min-värdena
				Font font = new Font( box.display, new FontData( "Arial", 12, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
				e.gc.setFont(font);
				e.gc.drawText("min\nx:", 0,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText(create_scale_string(min_x_show[0]), 40,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText("max\nx:", 95,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText(create_scale_string(max_x_show[0]), 135,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText("min\ny:", 190,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText(create_scale_string(min_y_show[0]), 230,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText("max\ny:", 285,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText(create_scale_string(max_y_show[0]), 325,0, true); //true gör att ingen bakgrund ritas bakom texten
				
				
				//skriver ut namn och färg på plottarna, om linjerna inte
				//har namn sätts endast en siffra 1-5
				e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_BLUE));
				e.gc.setBackground(box.display.getSystemColor(SWT.COLOR_BLUE));
				e.gc.fillRectangle(0,40,10,10);
				if(box.get_inline(1)!=null && box.get_inline(1).title.equals("")==false )//linje kopplad och har namn
					e.gc.drawText(box.get_inline(1).title, 15,35, true); //true gör att ingen bakgrund ritas bakom texten
				else
					e.gc.drawText("1", 15,35, true); //true gör att ingen bakgrund ritas bakom texten
				
				e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_RED));
				e.gc.setBackground(box.display.getSystemColor(SWT.COLOR_RED));
				e.gc.fillRectangle(70,40,10,10);
				if(box.get_inline(2)!=null && box.get_inline(2).title.equals("")==false )//linje kopplad och har namn
					e.gc.drawText(box.get_inline(2).title, 85,35, true); //true gör att ingen bakgrund ritas bakom texten
				else
					e.gc.drawText("2", 85,35, true); //true gör att ingen bakgrund ritas bakom texten
				
				e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_DARK_GREEN));
				e.gc.setBackground(box.display.getSystemColor(SWT.COLOR_DARK_GREEN));
				e.gc.fillRectangle(140,40,10,10);
				if(box.get_inline(3)!=null && box.get_inline(3).title.equals("")==false )//linje kopplad och har namn
					e.gc.drawText(box.get_inline(3).title, 155,35, true); //true gör att ingen bakgrund ritas bakom texten
				else
					e.gc.drawText("3", 155,35, true); //true gör att ingen bakgrund ritas bakom texten
				
				e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_YELLOW));
				e.gc.setBackground(box.display.getSystemColor(SWT.COLOR_YELLOW));
				e.gc.fillRectangle(210,40,10,10);
				if(box.get_inline(4)!=null && box.get_inline(4).title.equals("")==false )//linje kopplad och har namn
					e.gc.drawText(box.get_inline(4).title, 225,35, true); //true gör att ingen bakgrund ritas bakom texten
				else
					e.gc.drawText("4", 225,35, true); //true gör att ingen bakgrund ritas bakom texten
				
				e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_MAGENTA));
				e.gc.setBackground(box.display.getSystemColor(SWT.COLOR_MAGENTA));
				e.gc.fillRectangle(280,40,10,10);
				if(box.get_inline(5)!=null && box.get_inline(5).title.equals("")==false )//linje kopplad och har namn
					e.gc.drawText(box.get_inline(5).title, 295,35, true); //true gör att ingen bakgrund ritas bakom texten
				else
					e.gc.drawText("5", 295,35, true); //true gör att ingen bakgrund ritas bakom texten
				
				//återställer färger
				e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_BLACK));
				e.gc.setBackground(box.display.getSystemColor(SWT.COLOR_WIDGET_BACKGROUND));
				
				
				//skriver ut värdet för där pekaren är
				e.gc.drawText("x:", 380,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText(create_scale_string(x_coord_val[0]), 380,18, true); //true gör att ingen bakgrund ritas bakom texten
				//skriver ut värdet för där pekaren är
				e.gc.drawText("y:", 435,0, true); //true gör att ingen bakgrund ritas bakom texten
				e.gc.drawText(create_scale_string(y_coord_val[0]), 435,18, true); //true gör att ingen bakgrund ritas bakom texten
				
				font.dispose();
			}
		});
		
		

		//canvasen som det plottas på
		plot_canvas = new Canvas(plot_shell,SWT.NO_REDRAW_RESIZE);
		GridData plot_canvas_grid_data = new GridData();
		plot_canvas_grid_data.verticalAlignment = GridData.FILL;
		plot_canvas_grid_data.horizontalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		plot_canvas_grid_data.horizontalSpan = 12;
		plot_canvas_grid_data.grabExcessVerticalSpace = true;
		plot_canvas_grid_data.grabExcessHorizontalSpace = true;
		//plot_canvas_grid_data.heightHint = 500;
		//plot_canvas_grid_data.widthHint = 500;
		plot_canvas.setLayoutData(plot_canvas_grid_data);
		
		
		plot_shell.setSize (500, 555);//canvasen upptill är 55, knapparna 30
		plot_shell.setText(box.title);
		//plot_shell.pack();
		plot_shell.open();//om den inte är här ritar den två ggr när man
		//öppnar canvasen genom att dubbelklicka
		
		//lokal klass
		//räknar ut riktiga värden
		//variabler som sparas från plotalgoritmen för att kunna räkna ut
		//pekarens riktiga värde för ett visst pixelvärde
		final int offs_xl_save[]={0};
		final double x_pixel_range_save[]={0};
		final double x_scale_min_save[]={0};
		final int offs_yd_save[]={0};
		final int y_size_save[]={0};
		final double y_pixel_range_save[]={0};
		final double y_scale_min_save[]={0};
		class calc_val{//lokal klass

			//räknar ut x:s riktiga värde
			public double real_x_val(int pixel_x){
				int x_no_offs = pixel_x-offs_xl_save[0];//tar bort offset
				double x_real = x_no_offs*x_pixel_range_save[0]+x_scale_min_save[0];//räknar ut dess värde i x-skalan
				return x_real;
			}

			//räknar ut y:s riktiga värde
			public double real_y_val(int pixel_y){
				int y_no_offs_corr = y_size_save[0]-pixel_y-offs_yd_save[0];
				double y_real = y_no_offs_corr*y_pixel_range_save[0] + y_scale_min_save[0];
				return y_real;
			}

		}
		
		
		//start/slut-värden för zoom-rutan
		final int x_start[]={0};
		final int x_end[]={0};
		final int y_start[]={0};
		final int y_end[]={0};	
		//nya max/min när zoom/pan skett som sätts i plotalgoritmen
		final double x_max_zoom[]={0};
		final double x_min_zoom[]={0};
		final double y_max_zoom[]={0};
		final double y_min_zoom[]={0};
		//min/max vars avstånd ubblas/halveras av zoom in/out
		final double min_x_save[]={0};
		final double max_x_save[]={0};
		final double min_y_save[]={0};
		final double max_y_save[]={0};
		//andra värdet i skalorna för att kunna räkna ut steg vid flytt
		final double x_scale_second_save[]={0};
		final double y_scale_second_save[]={0};
		//musens x/y-värden som används för att räkna ut koordinatvärdet
		//som skrivs ut upptill
		final int x_pos[]={0};
		final int y_pos[]={0};
		
		plot_canvas.addMouseListener(new MouseAdapter() {
		    public void mouseDoubleClick(MouseEvent e) {
		    
		    }
		    
		    public void mouseDown(MouseEvent e) {
		    	
		    	if(zoom_flag[0]==0 || zoom_flag[0]==1 || zoom_flag[0]==2 ){//zoomar med ruta
					if(zoom_flag[0]==0){//kvadratisk zoom
						x_start[0]=e.x;
						y_start[0]=e.y;
						x_end[0]=e.x;
						y_end[0]=e.y;
					}
					else if(zoom_flag[0]==1){//horisontell zoom
						x_start[0]=e.x;
						y_start[0]=0;
						x_end[0]=e.x;
						y_end[0]=0;
					}
					else if(zoom_flag[0]==2){//vertikal zoom
						x_start[0]=0;
						y_start[0]=e.y;
						x_end[0]=0;
						y_end[0]=e.y;
					}
					
					zoom_square_flag[0]=true;
				}
				
				
		    	
		    	
		    	
		    }
		    
		    public void mouseUp(MouseEvent e) {
		    	System.out.println("mopuseup");
		    	
		    	
		    	//hämtar canvasen och dess storlek
				Canvas canvas = (Canvas) e.widget;
				int x_size = canvas.getSize().x;
				int y_size = canvas.getSize().y;
				
				
				if(zoom_square_flag[0]==true ){//slutpunkten för zoom
					if(zoom_flag[0]==0){//kvadratisk zoom
						x_end[0]=e.x;
						y_end[0]=e.y;
					}
					else if(zoom_flag[0]==1){//horisontell zoom
						x_end[0]=e.x;
						y_end[0]=y_size;
					}
					else if(zoom_flag[0]==2){//vertikal zoom
						x_end[0]=x_size;
						y_end[0]=e.y;
					}
					
					//nya max/min
					x_min_zoom[0]=Math.min(new calc_val().real_x_val(x_start[0]), new calc_val().real_x_val(x_end[0])  );
					x_max_zoom[0]=Math.max(new calc_val().real_x_val(x_start[0]), new calc_val().real_x_val(x_end[0])  );
					//ej bakvänt, klassen tar hand om det
					y_min_zoom[0]=Math.min(new calc_val().real_y_val(y_start[0]), new calc_val().real_y_val(y_end[0])  );
					y_max_zoom[0]=Math.max(new calc_val().real_y_val(y_start[0]), new calc_val().real_y_val(y_end[0])  );
					
					zoom_square_flag[0]=false;
					activate_zoom_flag[0]=0;
					
					System.out.println("zoom activate");
					if(GoSim.process==null){
						plot_canvas.redraw();
					}
				}
		    	
		    }
		    
		});
		
		plot_canvas.addMouseMoveListener(new MouseMoveListener() {
			public void mouseMove(MouseEvent e){
				
				//hämtar canvasen och dess storlek
				Canvas canvas = (Canvas) e.widget;
				int x_size = canvas.getSize().x;
				int y_size = canvas.getSize().y;
				
				if(zoom_square_flag[0]==true ){//klickat för zoom

					if(zoom_flag[0]==0){//kvadratisk zoom
						x_end[0]=e.x;
						y_end[0]=e.y;
					}
					else if(zoom_flag[0]==1){//horisontell zoom
						x_end[0]=e.x;
						y_end[0]=y_size;
					}
					else if(zoom_flag[0]==2){//vertikal zoom
						x_end[0]=x_size;
						y_end[0]=e.y;
					}
					
				}
				
				//koordinaternas värde
				//koordinaterna sparas och deras värde räknas ut i
				//plotalgoritmen när skalorna ändras och när musen rörs
				x_pos[0]=e.x;
				y_pos[0]=e.y;

				
				//behöver bara uppdatera när sim ej körs eftersom
				//den ändå uppdateras vid sim
				//att uppdatera vid sim slöar ner allt väldigt mycket när
				//man rör musen
				if(GoSim.process==null){
					plot_canvas.redraw();
				}
				
				
				
			}
		});
		    
		
		
		plot_canvas.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
				if(zoom_square_flag[0]==true ){//ritar zoom-rutan
					e.gc.setAlpha(50);//0==genomskinlig
					e.gc.setBackground(box.display.getSystemColor(SWT.COLOR_BLUE) );
					e.gc.fillRectangle(x_start[0],y_start[0],x_end[0]-x_start[0],y_end[0]-y_start[0]);
					e.gc.setAlpha(255);//ogenomskinlig (opaque)
				}
				
				
				
//-------plotalgoritmen startar här				
				//kopierar listorna som ska plottas
				ArrayList data_x=null;
				ArrayList data_y1=null;
				//alla listor läggs i en lista som itereras över beroende på 
				//antal insignaler
				ArrayList all_cloned_data = new ArrayList();
//				all_cloned_data.add(data_x);
//				all_cloned_data.add(data_y1);
//				all_cloned_data.add(data_y2);
//				all_cloned_data.add(data_y3);
//				all_cloned_data.add(data_y4);
//				all_cloned_data.add(data_y5);
				

				//listorna är null när ny fil öppnas eftersom listan ej
				//sparas (transient)
				if(data_x_in!=null){
					//data_x=(ArrayList)data_x_in.clone();
					//data_y1=(ArrayList)data_y1_in.clone();
					//ovan kvar för läsbarhet, används i villkor
					
					//flera variabler
					//klonar alla listor med lästa värden
					for(int i=0;i<scope_inputs_plot+1 ;i++){//+1 för x
						all_cloned_data.add(  ((ArrayList)all_in_data.get(i)).clone()  );
					}
					//för läsbarhet, används i villkor
					data_x=(ArrayList) ((ArrayList)all_cloned_data.get(0)).clone();
					data_y1=(ArrayList) ((ArrayList)all_cloned_data.get(1)).clone();
					
					

					//kan vara en kortare än den andra eftersom data läses in
					//samtidigt som det plottas vilket då y är kortare 
					//ger outofbounds, (x används för for-loopernas villkor)
					//så y får inte vara kortare än x
					//gör inget om nån y är längre än x, så kollar bara den 
					//lista som sist läses in
					//if(data_y1.size() < data_x.size() )
					//	data_x.remove(data_x.size()-1);
					
					//flera variabler, denna är korrekt och fungerar men ibland blir det nåt
					//nullpointexc i for-satser för y
					//if( ((ArrayList)all_cloned_data.get(scope_inputs_plot ) ).size() < data_x.size() )
					//	data_x.remove(data_x.size()-1);
					
					//mycket hård kontroll av längden på data_x som används i 
					//många for-satser. Om nån y-lista är kortare än den minskas
					//data_x till den är lika lång.
					//har hänt att den ger nullpointexc så detta är en
					//säkerhetsgrej om nåt skulle gå fel i inläsningen
					ArrayList alt = new ArrayList();//temp, array-list-temp
					for(int i=1;i<scope_inputs_plot+1 ;i++){//+1 för x, i=1 tar ej med x
						alt=(ArrayList)all_cloned_data.get(i);//y1,y2...
						while(alt.size() < data_x.size() ){//minskar data_x tills de är lika långa
							data_x.remove(data_x.size()-1);
						}
					}
					

					
				}
				else{
					data_x=new ArrayList();
					data_x.add(new Double(0) );//tar ut detta värde nedtill, så sätter in ett element för att slippa outofbounds
					data_y1=new ArrayList();
					data_y1.add(new Double(0) );
					//låter ovan vara kvar för flera plottar för läslighet
					//variablerna används för villkor och startvärden
					
					//flera variabler
					for(int i=0;i<scope_inputs_plot+1 ;i++){//+1 för x
						all_cloned_data.add(new ArrayList() );
						((ArrayList)all_cloned_data.get(i)).add(new Double(0) );
					}
					
					
				}
				//listorna är tomma när man skapar blocket
				if(data_x.size()==0){
					data_x.add(new Double(0) );//tar ut detta värde nedtill, så sätter in ett element för att slippa outofbounds
					data_y1.add(new Double(0) );
					//låter ovan vara kvar för flera plottar för läslighet
					//variablerna används för villkor och startvärden
					
					//flera variabler
					for(int i=0;i<scope_inputs_plot+1 ;i++){//+1 för x
						((ArrayList)all_cloned_data.get(i)).add(new Double(0) );
					}
				}

				


				System.out.println("data_x.size(): "+data_x.size());

				//punkternas max och min x/y-värde hittas
				double max_x=((Double)data_x.get(0)).doubleValue();
				double min_x=((Double)data_x.get(0)).doubleValue();
				double max_y=((Double)data_y1.get(0)).doubleValue();
				double min_y=((Double)data_y1.get(0)).doubleValue();
				ArrayList alt=null;//array-list-temp
				for(int k=0;k<scope_inputs_plot+1 ;k++){//+1 för x
					alt=(ArrayList)all_cloned_data.get(k) ;
					for(int i=0;i<data_x.size();i++){
						if(k==0){//x
							if( ((Double)alt.get(i)).doubleValue() > max_x )
								max_x=((Double)alt.get(i)).doubleValue();

							if( ((Double)alt.get(i)).doubleValue() < min_x )
								min_x=((Double)alt.get(i)).doubleValue();
						}
						else{//y1-5
							if( ((Double)alt.get(i)).doubleValue() > max_y )
								max_y=((Double)alt.get(i)).doubleValue();

							if( ((Double)alt.get(i)).doubleValue() < min_y )
								min_y=((Double)alt.get(i)).doubleValue();
						}
					}
				}

				System.out.println("max_x: "+max_x+" "+"min_x: "+min_x);
				System.out.println("max_y: "+max_y+" "+"min_y: "+min_y);

//--------------ej plotalgoritm
				//dessa värden visas på den lilla canvasen upptill
				max_x_show[0]=max_x;
				min_x_show[0]=min_x;
				max_y_show[0]=max_y;
				min_y_show[0]=min_y;

				//skalgrejer, om användaren väljer auto/manuell skala:
				if(!x_min_auto_flag){//manuell x-min
					min_x=x_min_set;
					if(x_max_auto_flag && max_x < min_x)//om x_max är auto måste det värdet vara större än min, om inte sätter max till ett större än min
						max_x=min_x+1;
				}
				if(!x_max_auto_flag || x_max_sim_stop_flag){//manuell x-max
					max_x=x_max_set;
					if(x_min_auto_flag && max_x < min_x)//om x_min är auto måste det värdet vara mindre än ax, om inte sätter min till ett mindre än max
						min_x=max_x-1;
				}
				if(!y_min_auto_flag){//manuell y-min
					min_y=y_min_set;
					if(y_max_auto_flag && max_y < min_y)//om y_max är auto måste det värdet vara större än min, om inte sätter max till ett större än min
						max_y=min_y+1;
				}
				if(!y_max_auto_flag){//manuell y-max
					max_y=y_max_set;
					if(y_min_auto_flag && max_y < min_y)//om y_min är auto måste det värdet vara mindre än max, om inte sätter min till ett mindre än max
						min_y=max_y-1;
				}
				//zoom med ruta
				if(activate_zoom_flag[0]==0){
					if(zoom_flag[0]==0 ){//kvadratisk
						min_x=x_min_zoom[0];
						max_x=x_max_zoom[0];
						min_y=y_min_zoom[0];
						max_y=y_max_zoom[0];
					}
					else if(zoom_flag[0]==1 ){//horisontell
						min_x=x_min_zoom[0];
						max_x=x_max_zoom[0];
						
					}
					else if(zoom_flag[0]==2 ){//vertikal
						min_y=y_min_zoom[0];
						max_y=y_max_zoom[0];
					}
					
					activate_zoom_flag[0]=3;//annars ändras den när man ändrar
					//zoom_flag
				}
				else if(activate_zoom_flag[0]==1 ){//zoom in
					//avstånden mellan max och min halveras
					double diff_x = max_x_save[0]-min_x_save[0];
					max_x = max_x_save[0] - diff_x/4;
					min_x = min_x_save[0] + diff_x/4;
					double diff_y = max_y_save[0]-min_y_save[0];
					max_y = max_y_save[0] - diff_y/4;
					min_y = min_y_save[0] + diff_y/4;
					
					activate_zoom_flag[0]=3;//håll zoomat max/min
					//annars förstoras den jämt när man rör musen eller på
					//annat sätt uppdaterar denna canvas
				}
				else if(activate_zoom_flag[0]==2 ){//zoom out
					//avstånden mellan max och min dubblas
					double diff_x = max_x_save[0]-min_x_save[0];
					max_x = max_x_save[0] + diff_x/2;
					min_x = min_x_save[0] - diff_x/2;
					double diff_y = max_y_save[0]-min_y_save[0];
					max_y = max_y_save[0] + diff_y/2;
					min_y = min_y_save[0] - diff_y/2;
					
					activate_zoom_flag[0]=3;//håll zoomat max/min
					//annars förstoras den jämt när man rör musen eller på
					//annat sätt uppdaterar denna canvas
				}
				else if(activate_zoom_flag[0]==3 ){//håll zoomat min/max
					max_x = max_x_save[0];
					min_x = min_x_save[0];
					max_y = max_y_save[0];
					min_y = min_y_save[0];
				}
				else if(activate_zoom_flag[0]==4){//flytta vänster
					min_x=min_x_save[0]+(x_scale_second_save[0]-x_scale_min_save[0] );
					max_x=max_x_save[0]+(x_scale_second_save[0]-x_scale_min_save[0] );
					
					max_y = max_y_save[0];
					min_y = min_y_save[0];
					
					activate_zoom_flag[0]=3;//håll zoomat max/min
					//annars flyttas den hela tiden när canvas ritas om
				}
				else if(activate_zoom_flag[0]==5){//flytta höger
					min_x=min_x_save[0]-(x_scale_second_save[0]-x_scale_min_save[0] );
					max_x=max_x_save[0]-(x_scale_second_save[0]-x_scale_min_save[0] );
					
					max_y = max_y_save[0];
					min_y = min_y_save[0];
					
					activate_zoom_flag[0]=3;//håll zoomat max/min
					//annars flyttas den hela tiden när canvas ritas om
				}
				else if(activate_zoom_flag[0]==6){//flytta upp
					max_x = max_x_save[0];
					min_x = min_x_save[0];
					
					min_y=min_y_save[0]-(y_scale_second_save[0]-y_scale_min_save[0] );
					max_y=max_y_save[0]-(y_scale_second_save[0]-y_scale_min_save[0] );
					
					activate_zoom_flag[0]=3;//håll zoomat max/min
					//annars flyttas den hela tiden när canvas ritas om
				}
				else if(activate_zoom_flag[0]==7){//flytta ner
					max_x = max_x_save[0];
					min_x = min_x_save[0];
					
					min_y=min_y_save[0]+(y_scale_second_save[0]-y_scale_min_save[0] );
					max_y=max_y_save[0]+(y_scale_second_save[0]-y_scale_min_save[0] );
										
					activate_zoom_flag[0]=3;//håll zoomat max/min
					//annars flyttas den hela tiden när canvas ritas om
				}
//--------------plotalgoritm fortsätter				
				
				
				//om min=max öka/minska med ett så en skala kan skapas, annars blir det NaN/inf i skalan vilket ger error
				if(min_x==max_x){
					min_x--;
					max_x++;
				}
				if(min_y==max_y){
					min_y--;
					max_y++;
				}
				
				System.out.println("max_x: "+max_x+" "+"min_x: "+min_x);
				System.out.println("max_y: "+max_y+" "+"min_y: "+min_y);
				
				//x-skalan
				LinkedList x_scale = create_scale(max_x, min_x);
				//max/min för x-skalan
				double x_scale_min = ((Double)x_scale.getFirst()).doubleValue();
				double x_scale_max = ((Double)x_scale.getLast()).doubleValue();

				//y-skalan
				LinkedList y_scale = create_scale(max_y, min_y);
				//max/min för y-skalan
				double y_scale_min = ((Double)y_scale.getFirst()).doubleValue();
				double y_scale_max = ((Double)y_scale.getLast()).doubleValue();

				//hämtar canvasen och dess storlek
				Canvas canvas = (Canvas) e.widget;
				int x_size = canvas.getSize().x;
				int y_size = canvas.getSize().y;
				//offset till kanterna för plotten, i canvas-skala
				int offs_xl=55;//offset x left
				int offs_xr=25;//offset x right
				int offs_yu=20;//offset y up
				int offs_yd=40;//offset y down
				//storleken på diagrammet
				int x_grid_size=x_size-offs_xl-offs_xr;
				int y_grid_size=y_size-offs_yu-offs_yd;

				//e.gc.drawText("hej", 0,0, true); //true gör att ingen bakgrund ritas bakom texten

				System.out.println("x_grid_size: "+x_grid_size+" "+"y_grid_size: "+y_grid_size);

				//ritar skalorna
				//tar max-min-värdet och delar på antal x/y-punkter för canvasen
				//detta ger värdet som varje pixel har. 
				double x_pixel_range = (x_scale_max-x_scale_min)/x_grid_size;
				double y_pixel_range = (y_scale_max-y_scale_min)/y_grid_size;
				int x;//tempvärden bara, för enklare kod, används på olika ställen
				int y;
				Font font = new Font( box.display, new FontData( "Arial", 12, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
				e.gc.setFont(font);
				e.gc.setLineStyle(SWT.LINE_DOT);
				e.gc.setBackground(box.display.getSystemColor(SWT.COLOR_BLACK));
				for(int i=0;i<x_scale.size();i++){//x-skalan
					x=(int)Math.round( ((Double)x_scale.get(i)).doubleValue()/x_pixel_range );
					//offsettar x så den hamnar inom pixelvärdena, +/-
					//beroende på om funktionen är under/över 0
					if(x_scale_min<0)
						x=x+(int)Math.abs(Math.round( x_scale_min/x_pixel_range )) ;
					if(x_scale_min>0)
						x=x-(int)Math.abs(Math.round( x_scale_min/x_pixel_range )) ;
					//kommenterade är linjer inom skalan
					//e.gc.drawLine(x+offs_xl, offs_yu, x+offs_xl, offs_yu+y_grid_size);
					e.gc.drawLine(x+offs_xl, 0, x+offs_xl, y_size);
					
					//skriver skal-värdet
					//skapar sträng att skriva för skalans värde:
					String ss = create_scale_string( ((Double)x_scale.get(i)).doubleValue() );
					//vidden som ss har i pixlar
					int ss_x = e.gc.textExtent(ss).x;
					e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_WHITE));
					e.gc.drawText(ss, x+offs_xl-ss_x/2, offs_yu+y_grid_size+4, false); //true gör att ingen bakgrund ritas bakom texten
					e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_BLACK));
				}
				for(int i=0;i<y_scale.size();i++){//y-skalan
					y=(int)Math.round( ((Double)y_scale.get(i)).doubleValue()/y_pixel_range );
					//offsettar y så den hamnar inom pixelvärdena, +/-
					//beroende på om funktionen är under/över 0
					if(y_scale_min<0)
						y=y+(int)Math.abs(Math.round( y_scale_min/y_pixel_range )) ;
					if(y_scale_min>0)
						y=y-(int)Math.abs(Math.round( y_scale_min/y_pixel_range )) ;
					//vänder upp och ned på y-värden eftersom javas koordinatsystem
					//är efterblivet (upp till ner)
					//tar antal max antal pixlar i y-led för canvasen minus alla
					//punkter
					y=y_grid_size-y;
					
					//kommenterade är linjer inom skalan
					//e.gc.drawLine(offs_xl, y+offs_yu, offs_xl+x_grid_size, y+offs_yu);
					e.gc.drawLine(0, y+offs_yu, x_size, y+offs_yu);

					//skriver skal-värdet
					//skapar sträng att skriva för skalans värde:
					String ss = create_scale_string( ((Double)y_scale.get(i)).doubleValue() );
					//vidden/höjden som ss har i pixlar
					int ss_x = e.gc.textExtent(ss).x;
					int ss_y = e.gc.textExtent(ss).y;
					e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_WHITE));
					e.gc.drawText(ss, offs_xl-ss_x-4, y+offs_yu-ss_y/2, false); //true gör att ingen bakgrund ritas bakom texten
					e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_BLACK));
				}
				font.dispose();
				e.gc.setLineStyle(SWT.LINE_SOLID);


				//------plottar kurvan-----

				//x/y-värden skalade till heltal att passa inom
				//den ritade canvasen
				//flera listor i en lista, skalade värden, x,y1,y2...
				ArrayList xyl = new ArrayList();//xy-list
				for(int i=0;i<scope_inputs_plot+1 ;i++){//+1 för x
					xyl.add(new ArrayList() );
				}
				
				//skalar råa värden att passa i canvasen med korrekta
				//pixelvärden i formen Integer
				ArrayList alt1=new ArrayList();//array-list-temp1
				for(int k=0;k<scope_inputs_plot+1 ;k++){//+1 för x
					alt=(ArrayList)all_cloned_data.get(k);//råa värden
					alt1=(ArrayList)xyl.get(k);//skalade värden
					for(int i=0;i<data_x.size();i++){
						if(k==0){//x
							//data_x
							x=(int)Math.round( ((Double)alt.get(i)).doubleValue()/x_pixel_range );
							//offsettar x så den hamnar inom pixelvärdena, +/-
							//beroende på om funktionen är under/över 0
							//detta för om man ändrar skalan eller har horisontplot
							if(x_scale_min<0)
								x=x+(int)Math.abs(Math.round( x_scale_min/x_pixel_range )) ;
							if(x_scale_min>0)
								x=x-(int)Math.abs(Math.round( x_scale_min/x_pixel_range )) ;
							alt1.add(new Integer(x) );
						}
						else{//y
							//data_y1,y2...
							y=(int)Math.round( ((Double)alt.get(i)).doubleValue()/y_pixel_range );

							//offsettar y så den hamnar inom pixelvärdena, +/-
							//beroende på om funktionen är under/över 0
							if(y_scale_min<0)
								y=y+(int)Math.abs(Math.round( y_scale_min/y_pixel_range )) ;
							if(y_scale_min>0)
								y=y-(int)Math.abs(Math.round( y_scale_min/y_pixel_range )) ;
							//vänder upp och ned på y-värden eftersom javas koordinatsystem
							//är efterblivet (upp till ner)
							//tar antal max antal pixlar i y-led för canvasen minus alla
							//punkter
							y=y_grid_size-y;
							//System.out.println("x: "+x+" y: "+y);


							alt1.add(new Integer(y) );
						}

					}
				}
				
				for(int k=0;k<scope_inputs_plot+1 ;k++){//+1 för x
					System.out.println("antal element efter första behandling: "+((ArrayList)xyl.get(k)).size()   );
				}

				//alla punkter med samma x och y (skalade pixelvärden) tas bort
				//lägger unika värden i nya listor och ersätter de gamla
				//denna metod är mycket snabb
				//flera templistor i en lista som ska få unika värden och sen
				//ersätta den med alla int-punkter
				//två listor, en med x1,x2... och en med y1,y2... som ska plottas
				ArrayList x_points = new ArrayList();
				ArrayList y_points = new ArrayList();
				//x-listorna, index ändrat!
				for(int i=0;i<scope_inputs_plot ;i++){//
					x_points.add(new ArrayList() );
					((ArrayList)x_points.get(i)).add( ((ArrayList)xyl.get(0)).get(0) );//lägger till första värdet eftersom det är unikt, och nåt att börja ifrån
				}
				//y-listorna, index ändrat!
				for(int i=0;i<scope_inputs_plot ;i++){//
					y_points.add(new ArrayList() );
					((ArrayList)y_points.get(i)).add( ((ArrayList)xyl.get(i+1)).get(0) );//lägger till första värdet eftersom det är unikt, och nåt att börja ifrån
				}
				
				for(int k=1;k<scope_inputs_plot+1 ;k++){//+1 för x
					alt=(ArrayList)xyl.get(0);//x, alt är temp, arraylist-temp
					alt1=(ArrayList)xyl.get(k);//y1-5, alt1 är temp, arraylist-temp1
					for(int i=1;i<alt.size();i++){
						if( ((Integer)alt.get(i-1)).intValue()!=((Integer)alt.get(i)).intValue() || ((Integer)alt1.get(i-1)).intValue()!=((Integer)alt1.get(i)).intValue()  ){
							((ArrayList)x_points.get(k-1)).add(alt.get(i) );
							((ArrayList)y_points.get(k-1)).add(alt1.get(i) );
						}        			
					}
				}
				
				
				for(int k=0;k<scope_inputs_plot ;k++){
					System.out.println("antal element efter tagit bort samma punkter, x: "+ ((ArrayList)x_points.get(k)).size()  ); 
					System.out.println("antal element efter tagit bort samma punkter, y: "+ ((ArrayList)y_points.get(k)).size()  );
				}
				
				
				
//				//mjukar kurvan
//				//en punkt går i en cirkel, om riktningen är samma eller vågrät
//				//hela vägen i cirkeln blir det ett steg som motsvarar cirkelns
//				//radie. Ändras riktningen tas alla punkter med och ny cirkel
//				//"skapas".
//				ArrayList x_soft = new ArrayList();//den mjukade kurvan läggs här
//				ArrayList y_soft = new ArrayList();//den mjukade kurvan läggs här
//				int r=15;//cirkelns radie (pixlar, eller javapixlar)
//				int flag = 0;//flagga för algoritmen
//				//0: ny cirkel
//				//1: kollar riktning i cirkeln och om fortfarande i cirkeln
//				//2: alla i samma riktning/vågrät och avståndet större än radien,
//				//punkterna i cirkeln hoppas över
//				//3: riktning ändrats och inuti cirkeln, punkterna tas med
//				
//				
//				int start=0;//index för när nya cirkeln skapas
//				double sign=0;//riktning
//				int x1=0;//x ett steg fram i algoritmen, (för att räkna ut riktning)
//				int y1=0;//y ett steg fram i algoritmen
//				int xc=0;//koordinat för cirkelns center
//				int yc=0;
//				
//				
//				alt=(ArrayList)x_points.get(0);//x, alt är temp, arraylist-temp
//				alt1=(ArrayList)y_points.get(0);//y, alt är temp, arraylist-temp
//				for(int i=0;i<alt.size()-1 ;i++){
//					x=((Integer)alt.get(i) ).intValue();//aktuellt x
//					y=((Integer)alt1.get(i) ).intValue();
//					x1=((Integer)alt.get(i+1) ).intValue();//x ett steg fram
//					y1=((Integer)alt1.get(i+1) ).intValue();
//					
//					if(flag==0){//ny cirkel, uppdaterar start-index och riktning
//						
//						start=i;
//						sign=Math.signum(y1-y);
//						//System.out.println("flag0, i: "+i+" sign: "+sign);
//						xc=((Integer)alt.get(i) ).intValue();
//						yc=((Integer)alt1.get(i) ).intValue();
//						
//						flag=1;
//					}
//					else if(flag==1){//kollar riktning och om inuti cirkeln
//						//System.out.println("flag1, i: "+i+" sign: "+sign);
//						if(sign==0 || sign==-0){//vågrät linje måste specialbehandlas
//							sign=Math.signum(y1-y);//uppdaterar sign, villkoren tar hand om resten i algoritmen
//							//vågrät accepteras oavsett riktning
//							if(Math.sqrt((x1-xc)*(x1-xc)+(y1-yc)*(y1-yc) ) > r ){
//								flag=2;
//								i--;
//							}
//						}
//						else{
//							//System.out.println("Math.signum(y1-y): "+Math.signum(y1-y));
//							//System.out.println("Math.sqrt((x1-xc)*(x1-xc)+(y1-yc)*(y1-yc)): "+Math.sqrt((x1-xc)*(x1-xc)+(y1-yc)*(y1-yc)) );
//							//System.out.println("x1: "+x1+" y1: "+y1+" xc: "+xc+" yc: "+yc);
//							if(sign!=Math.signum(y1-y) && Math.signum(y1-y)!=0 && Math.signum(y1-y)!=-0 ){//ändrar riktning inuti cirkeln, vågrät är inte riktningsändring
//								flag=3;
//								i--;
//							}
//							else if(Math.sqrt((x1-xc)*(x1-xc)+(y1-yc)*(y1-yc) ) < r  ){//samma riktning och inuti cirkeln
//								flag=1;
//							}
//							else{// if(sign==Math.signum(y1-y) || Math.sqrt(x1*x1+y1*y1) > r)//samma riktning och utanför cirkeln
//								flag=2;
//								i--;
//							}
//						}
//					}
//					else if(flag==2){//samma riktning/vågrät, tar bara med första punkten
//						//System.out.println("flag2, i: "+i+" sign: "+sign);
//						x_soft.add(alt.get(start) );
//						y_soft.add(alt1.get(start) );
//						flag=0;
//						i--;
//					}
//					else if(flag==3){//ändrar riktning, första och aktuell punkt tas med
//						//System.out.println("flag3, i: "+i+" sign: "+sign);
//						x_soft.add(alt.get(start) );
//						y_soft.add(alt1.get(start) );
//						x_soft.add(alt.get(i) );
//						y_soft.add(alt1.get(i) );
//						flag=0;
//					}
//					
//					//sista punkten specialbehandlas
//					if(i==alt.size()-2){//näst sista index ger x1,y1 är sista
//						if(flag==0 ){
//							x_soft.add(alt.get(i) );
//							y_soft.add(alt1.get(i) );
//							x_soft.add(alt.get(i+1) );
//							y_soft.add(alt1.get(i+1) );
//						}
//						if( flag==1 || flag==2 || flag==3 ){
//							x_soft.add(alt.get(start) );
//							y_soft.add(alt1.get(start) );
//							x_soft.add(alt.get(i) );
//							y_soft.add(alt1.get(i) );
//							x_soft.add(alt.get(i+1) );
//							y_soft.add(alt1.get(i+1) );
//						}
//					}
//					
//				}
//				
//				System.out.println("x_soft.size(): "+x_soft.size() );
//				
//				x_points.remove(0);
//				y_points.remove(0);
//				x_points.add(x_soft );
//				y_points.add(y_soft );
				
				
				//        		//tillåter bara en punkt per x-värde om kurvan går i samma
				//        		//riktning
				//        		ArrayList x1lt = new ArrayList();//temp listor där punket som ska med, x1listtemp
				//        		ArrayList y1lt = new ArrayList();//läggs, x1l/y1l ändras till dessa sen
				//        		double y_direction=0;//riktning för y 
				//        		int x_first=0;//bugg i java som klagar på att den inte kan ha ett värde, därför görs detta 2 ggr, även i första iterationen
				//        		int y_first=0;
				//        		boolean one_time_flag = false;
				//        		boolean change_direction_flag = false;
				//        		int x_old;//x en sampel tidigare
				//        		int y_old;//y en sampel tidigare
				//        		for(int i=0;i<x1l.size();i++){
				//        			x=((Integer)x1l.get(i)).intValue();
				//        			y=((Integer)y1l.get(i)).intValue();
				//        			
				//            		if(i==0){//första punkten visas alltid
				//            			x1lt.add(new Integer(x) );
				//            			y1lt.add(new Integer(y) );
				//            			x_first=x;
				//            			y_first=y;
				//            		}
				//            		else{
				//            			x_old=((Integer)x1l.get(i-1)).intValue();//x från förra sampeln
				//            			y_old=((Integer)y1l.get(i-1)).intValue();//y från förra sampeln
				//            			if(x_first+0*scale_factor<x || change_direction_flag){//olika x, bestämmer steg här, 
				//            				//samma som pixelvidden på kurvan är nog bra
				//            				//steglängd
				//            				
				//            				
				//        					//om riktningen ändras för nytt x ta med föregående punkt
				//            				//tanken är att om det blir nytt x med ändrad riktning så vill
				//            				//man ha med punkten innan för att visa allt beteende
				//        					if(Math.signum(y-y_old)!=y_direction && one_time_flag && !change_direction_flag){
				//        						x1lt.add(new Integer(x_old) );
				//        						y1lt.add(new Integer(y_old) );
				//        						//System.out.println("old");
				//        					}
				//        					x1lt.add(new Integer(x) );
				//        					y1lt.add(new Integer(y) );
				//        					x_first=x;
				//        					y_first=y;
				//        					one_time_flag=false;
				//        					change_direction_flag=false;
				//            			}
				//            			else{
				//            				if(!one_time_flag){//kollar riktningen
				//            					y_direction=Math.signum(y-y_first);
				//            					one_time_flag=true;
				//            					if(y_direction==0){
				//            						System.out.println("riktning 0");
				//            						System.out.println("y: "+y+" y_first: "+y_first);
				//            						System.out.println("x: "+x+" x_first: "+x_first);
				//            						
				//            					}
				//            				}
				//            				else{
				//            					//om riktningen ändras ta med föregående punkt
				//            					//System.out.println(y_direction);
				//            					//System.out.println(Math.signum(y-y_old));
				//            					if(Math.signum(y-y_old)!=y_direction ){
				//            						change_direction_flag=true;
				//            						i--;
				//            						//System.out.println("ny riktning");
				//            					}
				//            				}
				//            			}
				//            		}
				//        		}
				//        		
				//        		//uppdaterar listorna som ska plottas:
				//        		x1l=x1lt;
				//        		y1l=y1lt;
				//        		System.out.println("x1lt.size(): "+x1lt.size());




				System.out.println("lägger punkterna i en vektor med alternerande x och y-värden...");
				//lägger punkterna i en vektor med alternerande x och y-värden
				//för att kunna rita vektorn
				//skalar också för offset vid kanterna
				ArrayList vector_list = new ArrayList();//lista med vektorer med
				//alternerande x/y-värden
				int k=-1;//spara i vektor
				for(int n=0;n<scope_inputs_plot ;n++){//
					vector_list.add( new int[((ArrayList)x_points.get(n)).size()   *2] );//längden för varje x1,x2,x3...*2
					for(int i=0; i< ((ArrayList)x_points.get(n)).size() ;i++){//längd för varje x-serie är stoppvillkoret
						((int[])vector_list.get(n))[++k]= ((Integer) ((ArrayList) x_points.get(n)).get(i)).intValue()  +offs_xl;
						((int[])vector_list.get(n))[++k]= ((Integer) ((ArrayList) y_points.get(n)).get(i)).intValue()  +offs_yu;
						//System.out.println("x1v[i]: "+x1v[i]+" y1v[i]: "+y1v[i]);
						//int y3 = ((Integer) ((ArrayList) x_points.get(n)).get(i)).intValue();
						
					}
					k=-1;
				}
				

				System.out.println("färdig med databehandling, plottar...");
				e.gc.setLineWidth(line_width.intValue() );
				//plottar med olika färger
				for(int i=0;i<scope_inputs_plot ;i++){//
					if(i==0)
						e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_BLUE));
					else if(i==1)
						e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_RED));
					else if(i==2)
						e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_DARK_GREEN));
					else if(i==3)
						e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_YELLOW));
					else if(i==4)
						e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_MAGENTA));
					
				e.gc.drawPolyline( (int[])vector_list.get(i) );
				}				
				e.gc.setForeground(box.display.getSystemColor(SWT.COLOR_BLACK));

				
//----plotalgoritmen klar, lilla canvasesn upptill:				
				//räknar ut koordinatvärdet här som skrivs upptill så att det
				//ändras när skalan ändras
				x_coord_val[0]= new calc_val().real_x_val(x_pos[0] );
				y_coord_val[0]= new calc_val().real_y_val(y_pos[0] );
				
				//ritar den lilla canvasen med max/min-värden
				data_canvas.redraw();
				data_canvas.update();
				
				
				
				//sparar variabler som behövs för att räkna ut vilket värde
				//ett pixel värde har, används för zoom och skriva ut
				//värdet för pekarens position
				//x:
				offs_xl_save[0]=offs_xl;
				x_pixel_range_save[0]=x_pixel_range;
				x_scale_min_save[0]=x_scale_min;
				//y:
				offs_yd_save[0]=offs_yd;
				y_size_save[0]=y_size;
				y_pixel_range_save[0]=y_pixel_range;
				y_scale_min_save[0]=y_scale_min;
				//min/max, för zoom in/ut
				min_x_save[0]=min_x;
				max_x_save[0]=max_x;
				min_y_save[0]=min_y;
				max_y_save[0]=max_y;
				//andra värdet i skalan för att kunna flytta åt olika håll (för att räkna ut flyttsteg)
				x_scale_second_save[0]= ((Double)x_scale.get(1) ).doubleValue();
				y_scale_second_save[0]= ((Double)y_scale.get(1) ).doubleValue();
			

			}
		});

		
		
		while (!plot_shell.isDisposed()) {
			if (!box.display.readAndDispatch())
				box.display.sleep();
		}

	}


	//skapar skala med lämpligt antal (nära 7) mellanrum som inhyser 
	//max- och min-värdet
	public LinkedList create_scale(double max_xy, double min_xy){

		double diff = max_xy-min_xy;
		//om min/max_xy är stora värden (som 1e20) blir denna differens 0
		//även med åtgärderna i plotalgoritmen som plussar och minusar med ett,
		//detta pga av flyttalsavrundning som ej är perfekt. Då måste man använda
		//BigDecimal. 
		//Skapar en skala där jag dubblar max och halverar min i detta fall.
		//beroende på tecken kan detta bli tvärtom, om negativt halveras max
		//och min dubbleras men avståndet ökar och man kan skapa en skala
		if(diff==0){
			//detta kommer aldrig ske om både max/min är noll, så behöver
			//inte kolla om båda är noll, om en är noll kommer den andra
			//bli bra
			if(Math.signum(max_xy)==1.0 )//positiv
				max_xy = 2.0*max_xy;
			else//negativ
				max_xy = 0.5*max_xy;
			
			if(Math.signum(min_xy)==1.0 )//positiv
				min_xy = 0.5*min_xy;
			else//negativ
				min_xy = 2.0*min_xy;
				
			diff = max_xy-min_xy;
		}
		
		//om max/min-värdena in är NaN sätts en skala från -1 till 1.
		//detta blir fallet om alla värden in är NaN. Om bara vissa är 
		//NaN borde inte detta ske eftersom riktiga värden då finns
		//för min/max
		if( new Double(max_xy).isNaN() || new Double(min_xy).isNaN() ){
			max_xy = 1.0;
			min_xy = -1.0;
		}
		

		

		//tar reda på tusental/tiotal osv för differensen mellan max och min
		//10^pow är basen som ska delas i olika stora delar och kolla
		//vilken delning som ger bäst antal avdelningar av axeln
		int pow = 0;
		for(int i=-500;i<500;i++){
			if(diff/Math.pow(10,i) < 1){
				pow=--i;//10^i är nu tusental/tiotal som max har
				break;			
			}
		}

		System.out.println("pow: "+pow);
		double base_split=Math.pow(10,pow);//denna ska delas i olika antal
		//delar och ses vilken del som ger mest lämpligt antal avdelningar
		//(närmast 7st)
		//blir särskilt stor skillnad när man går under 0(här också?)
		
		//dividerar med 10 och ökar i steg till max
		double div_10 = base_split/10;
		LinkedList div_10_l = new LinkedList(); //div_10_list
		//dividerar med 5 och ökar i steg till max
		double div_5 = base_split/5;
		LinkedList div_5_l = new LinkedList(); //div_5_list
		//dividerar med 2 och ökar i steg till max
		double div_2 = base_split/2;
		LinkedList div_2_l = new LinkedList(); //div_2_list
		//dividerar med 1 och ökar i steg till max
		double div_1 = base_split/1;
		LinkedList div_1_l = new LinkedList(); //div_10_list
		//multiplicerar med 2 och ökar i steg till max
		double mult_2 = base_split*2;
		LinkedList mult_2_l = new LinkedList(); //mult_2_list
		//multiplicerar med 5 och ökar i steg till max
		double mult_5 = base_split*5;
		LinkedList mult_5_l = new LinkedList(); //mult_5_list
		//multiplicerar med 10 och ökar i steg till max
		double mult_10 = base_split*10;
		LinkedList mult_10_l = new LinkedList(); //mult_10_list

		//första steget är första jämna indelningssteg... som 
		//indelningen har från min
		double first_even=Math.floor(min_xy/div_10)*div_10;
		div_10_l.add(new Double(first_even) );
		//ökar i steg till max
		int k=1;//multiplikator för baserna
		while(first_even+div_10*k < Math.ceil(max_xy/div_10)*div_10 ){
			div_10_l.add(new Double(first_even+div_10*k) );
			k++;
		}
		double last_even=Math.ceil(max_xy/div_10)*div_10;//sista jämna indelningssteg, separat efter loopen eftersom villkoret kan bli liiite över detta värde
		div_10_l.add(new Double(last_even) );
				
		first_even=Math.floor(min_xy/div_5)*div_5;
		div_5_l.add(new Double(first_even) );
		k=1;//multiplikator för baserna
		while(first_even+div_5*k < Math.ceil(max_xy/div_5)*div_5 ){
			div_5_l.add(new Double(first_even+div_5*k) );
			k++;
		}
		last_even=Math.ceil(max_xy/div_5)*div_5;//sista jämna indelningssteg, separat efter loopen eftersom villkoret kan bli liiite över detta värde
		div_5_l.add(new Double(last_even) );
		
		first_even=Math.floor(min_xy/div_2)*div_2;
		div_2_l.add(new Double(first_even) );
		k=1;//multiplikator för baserna
		while(first_even+div_2*k < Math.ceil(max_xy/div_2)*div_2 ){
			div_2_l.add(new Double(first_even+div_2*k) );
			k++;
		}
		last_even=Math.ceil(max_xy/div_2)*div_2;//sista jämna indelningssteg, separat efter loopen eftersom villkoret kan bli liiite över detta värde
		div_2_l.add(new Double(last_even) );
		
		first_even=Math.floor(min_xy/div_1)*div_1;//detta kan bli samma som min och ge dublett när min läggs till senare, kanske inte tillåta dublett? Spelar ingen roll egentligen
		div_1_l.add(new Double(first_even) );
		k=1;//multiplikator för baserna
		while(first_even+div_1*k < Math.ceil(max_xy/div_1)*div_1 ){
			div_1_l.add(new Double(first_even+div_1*k) );
			k++;
		}
		last_even=Math.ceil(max_xy/div_1)*div_1;//sista jämna indelningssteg, separat efter loopen eftersom villkoret kan bli liiite över detta värde
		div_1_l.add(new Double(last_even) );
		
		first_even=Math.floor(min_xy/mult_2)*mult_2;
		mult_2_l.add(new Double(first_even) );
		k=1;//multiplikator för baserna
		while(first_even+mult_2*k < Math.ceil(max_xy/mult_2)*mult_2 ){
			mult_2_l.add(new Double(first_even+mult_2*k) );
			k++;
		}
		last_even=Math.ceil(max_xy/mult_2)*mult_2;//sista jämna indelningssteg, separat efter loopen eftersom villkoret kan bli liiite över detta värde
		mult_2_l.add(new Double(last_even) );
		
		first_even=Math.floor(min_xy/mult_5)*mult_5;
		mult_5_l.add(new Double(first_even) );
		k=1;//multiplikator för baserna
		while(first_even+mult_5*k < Math.ceil(max_xy/mult_5)*mult_5 ){
			mult_5_l.add(new Double(first_even+mult_5*k) );
			k++;
		}
		last_even=Math.ceil(max_xy/mult_5)*mult_5;//sista jämna indelningssteg, separat efter loopen eftersom villkoret kan bli liiite över detta värde
		mult_5_l.add(new Double(last_even) );
		
		first_even=Math.floor(min_xy/mult_10)*mult_10;
		mult_10_l.add(new Double(first_even) );
		k=1;//multiplikator för baserna
		while(first_even+mult_10*k < Math.ceil(max_xy/mult_10)*mult_10 ){
			mult_10_l.add(new Double(first_even+mult_10*k) );
			k++;
		}
		last_even=Math.ceil(max_xy/mult_10)*mult_10;//sista jämna indelningssteg, separat efter loopen eftersom villkoret kan bli liiite över detta värde
		mult_10_l.add(new Double(last_even) );
		
		System.out.println("div_10_l: "+ div_10_l.size() );
		System.out.println("div_5_l: "+ div_5_l.size() );
		System.out.println("div_2_l: "+ div_2_l.size() );
		System.out.println("div_1_l: "+ div_1_l.size() );
		System.out.println("mult_2_l: "+ mult_2_l.size() );
		System.out.println("mult_5_l: "+ mult_5_l.size() );
		System.out.println("mult_10_l: "+ mult_10_l.size() );
		
		//hittar den lista som har närmast 5 element, om två är lika nära ta
		//den som är minst
		LinkedList all_lists = new LinkedList();
		all_lists.add(div_10_l);
		all_lists.add(div_5_l);
		all_lists.add(div_2_l);
		all_lists.add(div_1_l);
		all_lists.add(mult_2_l);
		all_lists.add(mult_5_l);
		all_lists.add(mult_10_l);
		

		LinkedList closest_to_7 = null;
		int d = 7;//antal indelningar, var från början 5 men blir för få indelningar ofta, använder 7 st ist.
		for(int i=0;i<all_lists.size();i++){
			if(i==0)
				closest_to_7=(LinkedList)all_lists.get(i);
			else{
				int temp = ((LinkedList)all_lists.get(i) ).size() ;
				if(Math.abs(temp-d) < Math.abs(closest_to_7.size()-d) )//närmast d indelningar
					closest_to_7=(LinkedList)all_lists.get(i);
				else if(Math.abs(temp-d) == Math.abs(closest_to_7.size()-d) ){
					//lika många indelningar ifrån d, tar den med minst
					if(temp < closest_to_7.size() )//om temp har färre ta den, annars behåll
						closest_to_7=(LinkedList)all_lists.get(i);
				}
			}
		}
		
		//Infinity-skala, max-min-skala, max-min i tredjedelar:
		//vid mkt stora/små värden kan skalvärden bli infinity och då går
		//det inte att räkna ut en skala eftersom ett värde/inf är noll
		//och alla skalvärden hamnar längst ner förutom kanske inf. 
		//Därför om nåt skalvärde har värdet infinity skapas en speciell
		//skala med endast min och max som skalvärden och max-min delad
		//i tredjedelar.
		//Detta är bara för 
		//att visa nåt och att programmet inte kraschar eftersom BigDecimal
		//inte kan hantera infinity och skalan blir ändå dålig om man ordnar
		//det.
		//Kollar om nåt skalvärde är infinity, skapar då max-min-skala.
		boolean inf_flag=false;//flagga för om skalan har ett inf-värde
		for(int i=0;i<closest_to_7.size();i++){
			if( ((Double)closest_to_7.get(i)).isInfinite() ){
				inf_flag=true;
				break; 
			}
		}
		//skapar max-min-skala om nåt värde i skalan var infinity
		if(inf_flag){
			closest_to_7.clear();
			closest_to_7.add(new Double(min_xy) );
			closest_to_7.add(new Double( min_xy+(max_xy-min_xy)/3) );//en tredjedel
			closest_to_7.add(new Double( min_xy+(max_xy-min_xy)/3*2) );//två tredjedelar
			closest_to_7.add(new Double(max_xy) );
		}
		
		
		
		System.out.println("closest_to_7.size(): "+closest_to_7.size() );
		for(int i=0;i<closest_to_7.size();i++){
			System.out.println(((Double)closest_to_7.get(i)).doubleValue() );
		}
		
		return closest_to_7;

		
	}
	
	
	
	
	
	
	//skapar sträng som skriv ut och visar skalans olika värden
	//strängen har lämpligt antal tecken och är rätt avrundad
	public String create_scale_string(double scale_value){
		
		//om alla värden in är NaN blir max/min NaN och detta ska 
		//visas i övre canvas
		//BigDecimal kan inte hantera NaN, skickar då tillbaka en sträng NaN
		if( Double.isNaN(scale_value) )
			return "NaN";
		//BigDecimal kan inte hantera infinity, skickar då tillbaka en sträng Inf.
		//sker i övre canvas som skriver ut detta värde
		if( Double.isInfinite(scale_value) )
			return "Inf";
					
		//skapar sträng som ser ut så här: 
		//000.00 eller 00000 fem siffror med ett komma om det finns
		//om det finns E ser det ut så här:
		//000.00 eller 00000
		//E+000        E+000
		//eller
		//-00.00 eller -0000
		//E+000        E+000
		//så ska försöka skapa det i denna metod med rätt avrundning
		
		String s="";//detta blir strängen som skickas tillbaka från denna metod		
		String t = Double.toString(scale_value);//för att kolla om det finns det minustecken först
		
		if(t.startsWith("-") ){//börjar med -, bara 4 siffror
			
			BigDecimal val = new BigDecimal(scale_value);
			val = val.round(new MathContext(4) );//4 signifikanta siffror, ger
			//4 tecken och eventuell punkt om talet är större än 0, men kan ge 
			//tal som 0.0002356 vilket inte är ok, de tas om hand med DecimalFormat
			val = val.stripTrailingZeros();//tar bort decimalnollor på slutet, samma värde

			s=val.toString();
			//System.out.println("s: "+s);
			//ger E+1, E+2... när det får plats med nollor, ordnar det
			if(s.endsWith("E+1") || s.endsWith("E+2") || s.endsWith("E+3")  )
				s=val.toPlainString();//skriver utan E
			//System.out.println("s1: "+s);
			//0.001235 eller flera nollor framme och/eller fler siffror på slutet
			//BigDecimal ger korrekt antal siffror över ca 6 nollor framtill så
			//då ska inte denna avrundning ske eftersom den av nån anledning sätter
			// , ist för .
			//endast om decimaltal, mer än 5 tecken och utan E för de är redan bra
			if(s.length()>1){//kan vara 0
				if(String.valueOf( s.charAt(1) ).equals("0") && s.indexOf(".")!=-1 && s.length()>5 && s.indexOf("E")==-1  ){ 
					DecimalFormat formatter = new DecimalFormat("#.###E0");
					s=formatter.format(val.doubleValue()) ;
					//System.out.println("hej");
				}
			}
			//System.out.println("s2: "+s);
			
		}
		else{//positivt tal, 5 siffror
		
			BigDecimal val = new BigDecimal(scale_value);
			val = val.round(new MathContext(5) );//5 signifikanta siffror, ger
			//5 tecken och eventuell punkt om talet är större än 0, men kan ge 
			//tal som 0.00023561 vilket inte är ok, de tas om hand med DecimalFormat
			val = val.stripTrailingZeros();//tar bort decimalnollor på slutet, samma värde

			s=val.toString();
			//System.out.println(s);
			//ger E+1, E+2... när det får plats med nollor, ordnar det
			if(s.endsWith("E+1") || s.endsWith("E+2") || s.endsWith("E+3") || s.endsWith("E+4")  )
				s=val.toPlainString();//skriver utan E
			//0.0012353 eller flera nollor framme och/eller fler siffror på slutet
			//BigDecimal ger korrekt antal siffror över ca 6 nollor framtill så
			//då ska inte denna avrundning ske eftersom den av nån anledning sätter
			// , ist för .
			//System.out.println(s);
			if(String.valueOf( s.charAt(0) ).equals("0") && s.indexOf(".")!=-1 && s.length()>6 && s.indexOf("E")==-1){ 
				DecimalFormat formatter = new DecimalFormat("#.####E0");
				s=formatter.format(val.doubleValue()) ;
			}

		}
		
		
		//om strängen innehåller E skapa ny rad där
		if(s.indexOf("E")!=-1){
			s=s.replaceFirst("E", "\nE");
		}
		
		return s;
		
	}
	
	//körs när simulering startas
	public void sim_start(){
		//sätter antal plottar som ska plottas
		scope_inputs_plot=scope_inputs.intValue();
		
		horizon_cnt = 0;//horisonträknaren nollställs
		
		//listorna är null när ny fil öppnas eftersom listan ej
		//sparas (transient)
		//skapar listorna för att kunna samla in data vid sim
		if(all_in_data==null){
			all_in_data = new ArrayList();//huvudlistan
			data_x_in = new ArrayList();
			data_y1_in = new ArrayList();
			data_y2_in = new ArrayList();
			data_y3_in = new ArrayList();
			data_y4_in = new ArrayList();
			data_y5_in = new ArrayList();
			//lägger inlistorna i en lista
			all_in_data.add(data_x_in);
			all_in_data.add(data_y1_in);
			all_in_data.add(data_y2_in);
			all_in_data.add(data_y3_in);
			all_in_data.add(data_y4_in);
			all_in_data.add(data_y5_in);
		}
		else{//tömmer listorna för ny data
			for(int i=0;i<all_in_data.size() ;i++){
				((ArrayList)all_in_data.get(i)).clear();
			}
		}
		
		//lägger fönstret längst fram om auto-show är valt
		if(auto_show_flag){
			try{//plot_shell är null första gången man klickar
				if(!plot_shell.isDisposed() )//öppen
					plot_shell.setActive();
				else{//stängd
				}
			}
			catch(Exception e){ //stängd
			}
		}
		
		//lägger runnable_plot i GUI-kön
		//startar runnable_plot om sim körs, denna börjar uppdatera och
		//snurra om fönstret är öppet
		if(plot_shell!=null){//är null om aldrig öppnats
			if(!plot_shell.isDisposed() )//öppet fönster
				box.display.asyncExec(runnable_plot);
		}
	}

	//körs när simulering stoppas
	public void sim_stop(){
	}
	
	//körs när GoSim stängs
	public void end_gosim_stop(){
		//stänger fönster om det är öppet
		try{//plot_shell kan vara null, kände för att göra nåt nytt...
			if(!plot_shell.isDisposed() )//öppet fönster
				plot_shell.dispose();
		}
		catch(Exception e){
		}
	}
	
	//körs när nån funktion skriver sträng med prefix g_s under simulering
	public void sim_update(String str){
		//kollar om str är menat till denna
		//System.out.println(str);
		//System.out.println(str.substring(4,4+box.script_name.length() ) );//boxens skriptnamn från strömmen
		if(box.script_name.equals(str.substring(4,4+box.script_name.length() ) ) ) {
			
			if(horizon_plot_flag){//horisontplot
				//x-värdet läses in
				double x = new Double( str.substring( str.indexOf("|o")+2, str.indexOf("|p") )  ).doubleValue();
				//inte rensa när man kommer till stopp, visa sista plotten
				//stopptiden:
				double stop = new Double(GoSim.stop_time).doubleValue();
				if(Math.floor(x/horizon)>horizon_cnt && x!=stop ){
					horizon_cnt = Math.floor(x/horizon);
				
					//tömmer alla listor
					for(int i=0;i<all_in_data.size() ;i++){
						((ArrayList)all_in_data.get(i)).clear();//tömmer alla listor
					}
					
				}
			}
			
			//läser in alla värden
			if(scope_inputs_plot==1){
				//om XY-plot så kan man radera all data vid vektorplot om man 
				//skickar ett särskilt meddelande "del" mellan |q och |r
				if(XY_plot_flag){
					String del = str.substring( str.indexOf("|q")+2, str.indexOf("|r") );
					if(del.equals("del") ){//töm alla listor
						for(int i=0;i<all_in_data.size() ;i++){
							((ArrayList)all_in_data.get(i)).clear();//tömmer alla listor
						}
					}
				}
				data_x_in.add(new Double( str.substring( str.indexOf("|o")+2, str.indexOf("|p") )  ));
				data_y1_in.add(new Double(  str.substring( str.indexOf("|p")+2, str.indexOf("|q") )  ));
			}
			else if(scope_inputs_plot==2){
				data_x_in.add(new Double( str.substring( str.indexOf("|o")+2, str.indexOf("|p") )  ));
				data_y1_in.add(new Double(  str.substring( str.indexOf("|p")+2, str.indexOf("|q") )  ));
				data_y2_in.add(new Double(  str.substring( str.indexOf("|q")+2, str.indexOf("|r") )  ));
			}
			else if(scope_inputs_plot==3){
				data_x_in.add(new Double( str.substring( str.indexOf("|o")+2, str.indexOf("|p") )  ));
				data_y1_in.add(new Double(  str.substring( str.indexOf("|p")+2, str.indexOf("|q") )  ));
				data_y2_in.add(new Double(  str.substring( str.indexOf("|q")+2, str.indexOf("|r") )  ));
				data_y3_in.add(new Double(  str.substring( str.indexOf("|r")+2, str.indexOf("|s") )  ));
			}
			else if(scope_inputs_plot==4){
				data_x_in.add(new Double( str.substring( str.indexOf("|o")+2, str.indexOf("|p") )  ));
				data_y1_in.add(new Double(  str.substring( str.indexOf("|p")+2, str.indexOf("|q") )  ));
				data_y2_in.add(new Double(  str.substring( str.indexOf("|q")+2, str.indexOf("|r") )  ));
				data_y3_in.add(new Double(  str.substring( str.indexOf("|r")+2, str.indexOf("|s") )  ));
				data_y4_in.add(new Double(  str.substring( str.indexOf("|s")+2, str.indexOf("|t") )  ));
			}
			else if(scope_inputs_plot==5){
				data_x_in.add(new Double( str.substring( str.indexOf("|o")+2, str.indexOf("|p") )  ));
				data_y1_in.add(new Double(  str.substring( str.indexOf("|p")+2, str.indexOf("|q") )  ));
				data_y2_in.add(new Double(  str.substring( str.indexOf("|q")+2, str.indexOf("|r") )  ));
				data_y3_in.add(new Double(  str.substring( str.indexOf("|r")+2, str.indexOf("|s") )  ));
				data_y4_in.add(new Double(  str.substring( str.indexOf("|s")+2, str.indexOf("|t") )  ));
				data_y5_in.add(new Double(  str.substring( str.indexOf("|t")+2, str.indexOf("|u") )  ));
			}
			
			
		}
	}
	
	
	

}
