import java.io.Serializable;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;


public class SignalGenerator implements FunctionIdentity, Serializable{
	
	//för serializable, en flagga för att detektera om man gör
	//stora ändringar i sin klass, inte ett måste men får bort en varning
	private static final long serialVersionUID = 1234L;
			
	Box box=null;
	String signal_type = "0";//signaltyp, fyrkantsvåg, toothwave etc...
	String period = "1";//signalens period i sekunder 
	String period_temp = "1"; //temp för GUI
	String signal_type_temp = "0";//temp för GUI
	
	//constructor
	public SignalGenerator(int x,int y, Display display_in, Shell sh, Canvas ca){
		
		box = new Box(x, y, display_in, sh, ca);
		box.set_number_inputs(0);
		box.set_number_outputs(1);
		box.create_menu();//måste vara efter set_inputs/outputs eftersom menyn behöver deras värden
		box.set_height_and_width(45,45);
		box.set_title("Signal\nGenerator");
		box.set_function_type(1);
		box.set_FunctionIdentity(this);
		
	}
	
	//ritar detta blocks utseende i boxen
	public void draw_graphics(){
		box.gc.setLineWidth(2);
		int[] points = {box.x_start+7,box.y_end-10,box.x_start+17,box.y_end-10,box.x_start+17,box.y_end-36,box.x_start+27,box.y_end-36,box.x_start+27,box.y_end-10,box.x_start+37,box.y_end-10};
		box.gc.drawPolyline(points);
	}
	
		//ger boxen detta funktionsobjekt sitter i
	public Box get_box(){
		return box;
	}
		
	//kopierar interfacet som instansierats som Add..nåt sånt...
	//blir en kopia iaf
	public FunctionIdentity copy(int x,int y, Display display_in, Shell sh, Canvas ca){
		return new SignalGenerator(x, y, display_in, sh, ca);
	}
	
	//ger strängen som ska skrivas för funktionen i skriptet
	public String get_function(){
		return "SignalGenerator";
	}
	
	//ger parametrar som användaren sätter för funktionen
	public String[] get_parameters(){
		return new String[]{"="+signal_type+";\n","="+period+";\n"};
	}
	
	//sträng som skrivs före loopen, "" gör att inget skrivs
	public String get_pre_loop_string(){
		return "";//pkg load control; %GoSim Control\n";
	}

	//sträng som skrivs efter loopen, "" gör att inget skrivs
	public String get_post_loop_string(){
		return "";
	}
	
	
	//GUI:t
	public void options(){
		final Shell options_shell = new Shell(this.box.shell, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		GridLayout grid_layout = new GridLayout();
		options_shell.setLayout(grid_layout);
		grid_layout.numColumns = 2;
		grid_layout.makeColumnsEqualWidth=true;



		//info-Text
		Text info_text = new Text(options_shell,SWT.READ_ONLY  | SWT.MULTI  | SWT.WRAP);// | SWT.V_SCROLL); //SWT.NULL);
		Font font = new Font( box.display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		info_text.setFont(font);
		info_text.setBackground(box.display.getSystemColor(SWT.COLOR_WIDGET_BACKGROUND));
		info_text.setText("This block generates different signals. " +
				"The amplitude is always one, change it with the gain block " +
				"and the offset with add/subtract.\n" +
				"17 and 18 reqiures the " +
				"period to be a multiple of the main loop sample time.\n\n"+
				"0. Square wave from -1 to 1.\n"+
				"1. Half square wave from 0 to 1: ⊓_⊓_⊓_⊓_⊓_\n" +
				"2. Half square wave from 0 to 1: _⊓_⊓_⊓_⊓_⊓\n" +
				"3. Saw tooth from -1 to 1: /|/|/|/|/|/|\n" +
				"4. Saw tooth from 0 to 1:  /|/|/|/|/|/|\n" +
				"5. Half saw tooth from 0 to 1: /|__/|__/|__/|__\n" +
				"6. Half saw tooth from 0 to 1: __/|__/|__/|__/|\n" +
				"7. Saw tooth from -1 to 1: |⧹|⧹|⧹|⧹|⧹|⧹\n" +
				"8. Saw tooth from 0 to 1:  |⧹|⧹|⧹|⧹|⧹|⧹\n" +
				"9. Half saw tooth from 0 to 1: |⧹__|⧹__|⧹__|⧹__\n" +
				"10. Half saw tooth from 0 to 1: __|⧹__|⧹__|⧹__|⧹\n" +
				"[fill space]                    /|     /|     /|     /|\n"+
				"11. Mixed from 0 to 1: | |__| |__| |__| |__\n" +
				"[fill space]                        /|     /|     /|     /|\n"+
				"12. Mixed from 0 to 1: __| |__| |__| |__| |\n" +
				"[fill space]                    |⧹     |⧹      |⧹     |⧹\n"+
				"13. Mixed from 0 to 1: | |__| |__| |__| |__\n" +
				"[fill space]                        |⧹     |⧹      |⧹     |⧹\n"+
				"14. Mixed from 0 to 1: __| |__| |__| |__| |\n" +
				"15. Triangle wave from -1 to 1: ⧸⧹⧸⧹⧸⧹⧸⧹⧸⧹⧸⧹\n"+
				"16. Triangle wave from 0 to 1:  ⧸⧹⧸⧹⧸⧹⧸⧹⧸⧹⧸⧹\n" +
				"17. Discrete Dirac delta function: |_____|_____\n"+
				"18. Discrete Dirac delta function: _____|_____|\n"+
				"19. Sine wave\n" +
				"20. Cosine wave\n");
		GridData info_text_grid_data= new GridData();
		info_text_grid_data.horizontalSpan = 2;
		//info_label_grid_data.heightHint = 700;
		info_text_grid_data.widthHint = 500;
		info_text.setLayoutData(info_text_grid_data);

		
		//Label
		Label label = new Label(options_shell, SWT.NULL);
		label.setFont(font);
		label.setText("Signal type:");

		//------TEXTFÄLT
		//tar in siffor till sampeltid och stop
		final Text var1_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//t1.setTabs(10);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		var1_text.setFont(font);
		var1_text.setFocus();
		var1_text.setText(signal_type );
		var1_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));

		GridData text_grid_data1 = new GridData();
		text_grid_data1.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		text_grid_data1.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		var1_text.setLayoutData(text_grid_data1);
		
		
		//Label
		Label label2 = new Label(options_shell, SWT.NULL);
		label2.setFont(font);
		label2.setText("Period (sec):");

		//------TEXTFÄLT
		//tar in siffor till sampeltid och stop
		final Text var2_text = new Text(options_shell, SWT.SINGLE | SWT.BORDER);// | SWT.RIGHT);
		//Font font = new Font( display, new FontData( "Arial", 16, SWT.NORMAL ) ); //namn, storlek, tjock/normal/kursiv
		var2_text.setFont(font);
		var2_text.setText(period );
		var2_text.setBackground(box.display.getSystemColor(SWT.COLOR_GRAY));

		GridData text_grid_data2 = new GridData();
		text_grid_data2.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.horizontalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		text_grid_data2.horizontalAlignment = GridData.FILL;
		//text_grid_data.grabExcessHorizontalSpace = true;
		//text_grid_data.heightHint = 20;
		//text_grid_data.widthHint = 100;
		var2_text.setLayoutData(text_grid_data2);

		
		
		
		//KNAPPAR
		final Button buttonOK = new Button(options_shell, SWT.PUSH);
		buttonOK.setFont(font);
		buttonOK.setText("Ok");
		GridData buttonOK_grid_data= new GridData();
		buttonOK_grid_data.verticalAlignment = GridData.FILL;
		//gridData2.verticalSpan = 2;
		//text_grid_data.grabExcessVerticalSpace = true;
		buttonOK_grid_data.horizontalAlignment = GridData.FILL;
		//buttonOK_grid_data.grabExcessHorizontalSpace = true;
		//buttonOK_grid_data.heightHint = 30;
		//buttonOK_grid_data.widthHint = 500;
		buttonOK.setLayoutData(buttonOK_grid_data);

		Button buttonCancel = new Button(options_shell, SWT.PUSH);
		buttonCancel.setFont(font);
		buttonCancel.setText("Cancel");
		buttonCancel.setLayoutData(buttonOK_grid_data);

		//LYSSNARE
		var1_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				signal_type_temp=var1_text.getText();
			}
		});
		var2_text.addListener(SWT.Modify, new Listener() {
			public void handleEvent(Event event) {
				period_temp=var2_text.getText();
			}
		});
		buttonOK.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				signal_type=signal_type_temp;
				period=period_temp;
				options_shell.dispose();
			}
		});
		buttonCancel.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				//om användaren trycker cancel efter att ändrat fält 1
	        	//men sen ändrar fält två ska inte fält 1 ändras
				signal_type_temp=signal_type;
				period_temp=period;
				options_shell.dispose();
			}
		});


		//script_shell.setSize (200, 200);
		options_shell.setText("Signal Generator Options");
		options_shell.pack();
		options_shell.open();
		while (!options_shell.isDisposed()) {
			if (!box.display.readAndDispatch())
				box.display.sleep();
		}
		
	}
	
	//sker när man dubbelklickar
	public void double_click_action(){
		options();
	}
	
	//körs när simulering startas
	public void sim_start(){

	}

	//körs när simulering stoppas
	public void sim_stop(){

	}
	
	//körs när GoSim stängs
	public void end_gosim_stop(){

	}
	
	//körs när nån funktion skriver sträng med prefix g_s under simulering
	public void sim_update(String str){
		
	}

}
